ASSEMBLE
    NIBASC /HPHP48-E/
RPL
     ( *bode plot of s domain transfer function, mag and phase* )
     ( *function of s on stack, must be a secondary which takes a real* )
     ( * from stack and returns a real, of form << -> s 'fn of s' >>* )
     ( *bode stack syntax:   seco real_1 real_2 --> grob* )
     ( *x limits are 10^real_1 .. 10^real_2* )
     ( *leaves 131x112 grob on stack, store in PICT to view* )
     ( * with graph editor, bottom half {off screen} is phase plot* )
     ( *this will change user flags to radians and rectangular modes* )
     ( *Randy Ding, Nov 1994* )
::
 CK3NOLASTWD
 CK&DISPATCH1 #811           ( *secondary object, real --> real'* )
 ::
  %0 %0
  { LAM H                    ( *the S-domain function* )
    LAM XLO                  ( *low limit is 10^XLO* )
    LAM XHI                  ( *high limit is 10^XHI* )
    LAM UL                   ( *mag plot upper limit* )
    LAM LL }                 ( *mag plot lower limit* )
  BIND

  LAM XLO
  %FLOOR
  DUP
  ' LAM XLO
  STOLAM
  LAM XHI
  %FLOOR
  DUP
  ' LAM XHI
  STOLAM
  %>=                        ( *exit now if x limits reversed or same* )
  case
  ABND

  SETRAD                     ( *radians mode, required by ARG function* )
  FIFTEEN
  ClrSysFlag                 ( *rectangular mode, -15 CF -16 CF* )
  SIXTEEN                    ( * required by %>C% function* )
  ClrSysFlag

  DEPTH #1+                  ( *save # args on stack for later test* )
  ' LAM LL                   ( * of user supplied function* )
  STOLAM                     ( *using LL for temp storage, resets %0 below* )
  % 69                       ( *test to make sure H returns a real number* )
  LAM H                      ( *test would fail if this number is a pole* )
  ERRSET
  EVAL
  ERRTRAP                    ( *trap ATTN keypress/error when in EVAL* )
  ::
   ABND
   AtUserStack
   ERRJMP
  ;
  DEPTH                      ( *H is a user function!, must return 1 real* )
  LAM LL                     ( * when given a real number, else exit prog* )
  #=
  NOTcase
  ABND                       ( *quit if more than 1 object returns from H* )
  TYPEREAL?                  ( *above may have left garbage on stack* )
  NOTcase
  ABND                       ( *quit if object returned was not a real* )
  %0
  ' LAM LL
  STOLAM

  TWENTYONE                  ( *do loop for 0 to 20 times X range* )
  ZERO_DO (DO)               ( *calc upper/lower limit for mag plot* )
   %0
   INDEX@
   UNCOERCE
   %20
   %/
   LAM XHI
   LAM XLO
   %-
   %*
   LAM XLO
   %+
   %ALOG
   %>C%
   LAM H
   ERRSET
   EVAL
   ERRTRAP                   ( *trap ATTN keypress when in EVAL* )
   ::
    ABND
    AtUserStack
    ERRJMP
   ;
   C%ABS                     ( *get mag of complex number* )
   %LOG
   %20
   %*
   DUP
   LAM UL
   %MAX
   ' LAM UL
   STOLAM
   LAM LL
   %MIN
   ' LAM LL
   STOLAM
  LOOP

  LAM LL                     ( *make lower lim 0 if it is positive* )
  %0>=
  IT
  ::
   %0
   ' LAM LL
   STOLAM
  ;

  RECLAIMDISP
  ClrDA1IsStat               ( *temp turn off ticking clock in display* )
  ZEROZERO
  112                        ( *112d = 56x2, display grob height* )
  BINT_131d
  MAKEGROB
  XYGROBDISP

  ZERO
  84
  BINT_130d
  OVER
  LINEON                     ( *draw a line in phase plot at 0 degrees* )

  ::                         ( *draw a line at 0 dB in mag plot* )
   LAM UL
   %SGN
   LAM LL
   %SGN
   %=
   ?SEMI                     ( *don't draw line, exit seco if same sign* )
   LAM UL
   DUP
   LAM LL
   %-
   %/
   % 55
   %*
   DUP
   %0<
   caseDROP                  ( *don't draw line if negative* )
   COERCE
   DUP
   FIFTYFIVE
   #>
   caseDROP                  ( *don't draw line if off screen* )
   DUP                       ( *save for tic marks below* )
   ZERO
   SWAP
   BINT_130d
   OVER
   LINEON

   #1+                       ( *Y value for tic marks* )
   LAM XHI                   ( *make tic marks* )
   LAM XLO
   %-
   DUP
   COERCE
   #1+
   ZERO_DO (DO)
    INDEX@
    BINT_130d
    #*
    UNCOERCE
    OVER
    %/
    COERCE
    DUP
    BINT_131d
    #<
    ITE
    ::
     3PICK
     PIXON
    ;
    DROP
   LOOP
   2DROP
  ;

  HARDBUFF
  SIXTYFOUR
  THREE                      ( *CENTER$ puts top of char at #y-3* )
  LAM UL
  a%>$,                      ( *convert real to $* )
  BINT_131d
  CENTER$3x5                 ( *grob #x #y $ #dispwidth --> grob* )

  SIXTYFOUR
  FIFTYFOUR
  LAM LL
  a%>$,
  $ "  MAG PLOT"
  &$                         ( *concatenate strings* )
  BINT_131d
  CENTER$3x5

  SIXTYFOUR
  FIFTYNINE
  $ "+180"
  BINT_131d
  CENTER$3x5

  SIXTYFOUR
  110
  $ "-180  PHASE PLOT"
  BINT_131d
  CENTER$3x5
  DROP                       ( *HARDBUFF* )

  66                         ( *do loop for 0 to 130 times X range* )
  ZERO_DO (DO)               ( *skipping every other pixel for more speed* )
   %0
   INDEX@
   #2*                       ( *to plot every point, remove three #2* lines* )
   UNCOERCE                  ( * and change loop count above to 131* )
   % 130
   %/
   LAM XHI
   LAM XLO
   %-
   %*
   LAM XLO
   %+
   %ALOG
   %>C%
   LAM H
   ERRSET
   EVAL
   ERRTRAP                   ( *trap ATTN keypress when in EVAL* )
   ::
    ABND
    HARDBUFF
    TOTEMPOB                 ( *leave what is finished of plot on stack* )
    AtUserStack
    ERRJMP
   ;
   DUP                       ( *dup result for mag and phase plots* )

   C%ABS                     ( *first plot mag, phase later in same pass* )
   %LOG
   %20
   %*
   LAM LL
   %-
   LAM UL
   LAM LL
   %-
   %/
   %1
   SWAP
   %-
   DUP
   %0<
   OVER
   % 1.009                   ( *greater than 1.009 would make result y=56* )
   %>                        ( * because COERCE rounds to nearest integer* )
   OR
   ITE                       ( *plot only if in range* )
   DROP
   ::
    % 55                     ( *now in range of 0-55* )
    %*
    COERCE
    INDEX@
    #2*
    SWAP
    PIXON
   ;

   C%ARG                     ( *plot phase* )
   %PI
   %+
   %2
   %/
   %PI
   %/
   %1
   SWAP
   %-
   DUP
   %0<
   OVER
   % 1.009
   %>
   OR
   ITE                       ( *plot only if in range* )
   DROP
   ::
    % 55
    %*
    COERCE
    FIFTYSIX
    #+                       ( *add 56 for bottom plot* )
    INDEX@
    #2*
    SWAP
    PIXON
   ;

   ATTN? IT                  ( *this will trap ATTN and abort program* )
   ::                        ( *in case it is not traped by EVAL trap* )
    ABND
    HARDBUFF                 ( *leave what is finished of plot on stack* )
    TOTEMPOB
    ZERO
    DO#EXIT
   ;
  LOOP
  ABND
  HARDBUFF                   ( *plot is finished, leave grob on stack* )
  TOTEMPOB
 ;
;
