ASSEMBLE

*  written by Randy Ding  July 30,1995
*  assembled with RPLCOMP/SASM/SLOAD from HPTOOLS, for 48 SX and GX
*  internet: randyd@crl.com
*
*  This program is designed for printing strings in columns on the hp display
*    using the 5x7 font.
*  String may have embedded line feeds for multiple lines.
*  Stack arguments are:   Y X $ --> Y2
*    Y is 0 to 6, or 7 if you change DISPHEIGHT to 8 (menu grob MUST BE OFF)
*    X is 0 to 21 column number
*    $ is "" string with embedded ^J's between lines.
*  The program returns Y2, the y value of the last line printed.  This
*  will be one line lower if you terminate your string with a ^J.
*  Complete error checking is provided, strings which go beyond the right
*  and/or bottom edge of display will be truncated.

           NIBASC  /HPHP48-E/

DISPWIDTH  EQU     22
NIBSPERROW EQU     34
DISPHEIGHT EQU     7           can change to 8 if menu will always be off

RPL

::
 CK3NOLASTWD
 CK&DISPATCH1 #113             ( *stack: %y %x $ --> %y2* )
 ::
  ROT COERCE
  ROT COERCE
  ROT
  CODE
*
* stack:  #y #x $ --> #y2      y=0, x=0 is upper left corner
*
           GOSBVL  =PopASavptr
           R0=A.F  A           --> $ prolog
           GOSBVL  =GETPTR
           GOSBVL  =POP#
           R2=A.F  A           #x
           GOSBVL  =POP#
           R3=A.F  A           #y
           GOSBVL  =SAVPTR
           A=R0.F  A
           D0=A
           D0=D0+  5
           A=DAT0  A
           A=A-CON A,5
           ASRB.F  A
           R1=A.F  A           $ char length
           D0=D0+  5
           AD0EX
           R0=A.F  A           --> $ body

NEXTROW    A=R3.F  A
           LC(5)   DISPHEIGHT
           ?A<C    A
           GOYES   CALCGROBY
           GOTO    EXITNOW1

CALCGROBY  GOSBVL  =D0->Row1
           C=0     A
           A=R3.F  A
           B=A     A
           LA(5)   (NIBSPERROW)*8
YMULLOOP   B=B-1   A
           GOC     YMULDONE
           C=C+A   A
           GOTO    YMULLOOP
YMULDONE   AD0EX
           A=A+C   A
           ASL     W           make room for a byte save below
           ASL     W
           R4=A                save --> grob

           A=R0.F  A
           D1=A                --> $
           D0=A
           A=R2.F  A           x
           LC(5)   DISPWIDTH
           ?A>=C   A           is x in range?
           GOYES   EXITNOW1
           C=C-A   A
           D=C     A           max chars from x to right edge of grob
           A=R1.F  A
           B=A     A           num chars remaining in $
           ?B=0    A
           GOYES   EXITNOW1
           C=0     A           num chars to print in this row

FINDEOLN   A=DAT0  B           read next char in $
           D0=D0+  2
           R4=A.F  B

           A=R0.F  A           inc $ ptr
           A=A+CON A,2
           R0=A.F  A

           A=R1.F  A           dec $ len
           A=A-1   A
           R1=A.F  A

           A=R4.F  B
           ABIT=0  1           clear these bits, if ^J it becomes 00
           ABIT=0  3
           ?A=0    B
           GOYES   NEXTY       go if it was a ^J
           ?D=0    A           reached right edge of grob yet?
           GOYES   DECLEN
           C=C+1   A           incr num chars to print this row
           D=D-1   A           decr width remaining in grob
DECLEN     B=B-1   A           decr string length remaining
           ?B=0    A
           GOYES   PRINTROW
           GOTO    FINDEOLN

EXITNOW1   GOTO    EXITNOW     booster for GOYES jumps out of range

NEXTY      A=R3.F  A           incr y, line feed
           A=A+1   A
           R3=A.F  A

PRINTROW   ?C=0    A           num chars to print this row
           GOYES   JUSTLF
           A=R4
           ASR     W           was shifted to make room for a byte buffer
           ASR     W
           D0=A                --> grob
           A=C     A
           LC(5)   NIBSPERROW
           D=C     A           nibs per row in grob
           C=A     A
           A=R2.F  A
           B=A     A           screen x location
           GOSBVL  =$5x7       D1 --> $ start for this row

JUSTLF     GOTO    NEXTROW

EXITNOW    A=R3.F  A
           GOVLNG  =PUSH#ALOOP
  ENDCODE
  UNCOERCE
 ;
;
