***** Jazz Scroll Bar ********************************************************
******************************************************************************
* Author        : Richard Steventon
* Description   : shows user flags 1 to 6 with a scroll bar for JAZZ flags
*               : [+/-] key toggles the flag (indicated by a "tick" mark)
* History       : completed 2 September 1994
*               : revised 05.12.94      Will Laughlin
* !!!!!!!!!!!!!!!!  FOR RPLCOMP.EXE  !!!!!!!! OR JAZZ  :-) !!!!!!!!!!!!!!!!!!!
* ENTRY         : no arguments required
* EXIT          : nothing returned
* Error Exit    : none (you are on your own!)
* USES  : A.A :
*         B.A :
*         C.A :
*         D.A : Current line
*         D0  : write address in grob (reinitialized for each write)
*         R2  : current line being displayed    : Only used during screen write
*         R4  : Timer value 
* NO LONGER USED        
*         R0  : Inc For Disp
*         R1  : amount to inc by
*         R3  : StringTab start address         : Only used during screen write
* CALLS : SAVPTR, GETPTRLOOP, DisableIntr, AllowIntr
*       : AINRTN        : does A=IN, RTN (on an even address)
*       : D0->Row1      : D1 = beginning of HARDBUFF (sx & gx)
*       : Kbd_OR        : checks whether a key is pressed -> Carry if True
*       : ThisKeyDn?    : checks whether the key specified by the keycode 
*                         in C.B is down -> Carry if True
*       : $5x7          : displays string (see code for register description)
* NO LONGER CALLED
*       : ASLW5         : does ASL  W  five times.... go figure.
*       
******************************************************************************

ASSEMBLE
*ThisKeyDn?     EQU     #00C8D
********** GX specific entry points ******************************************
*UserFlagsGX     EQU     #80853
********** ST FLAGS **********************************************************
sFAST           EQU     0
sClear?         EQU     1
********** Defines ***********************************************************
sTOP            EQU     2
sBOTTOM         EQU     7
*Flag1           EQU     0
*Flag2           EQU     1
*Flag3           EQU     2
*Flag4           EQU     3
*Flag5           EQU     4
*Flag6           EQU     5
RPL
CODE
	TITLE JAZZ Scroll Bar
	STITLE SJ was here 05.12.94

	GOSBVL  =SAVPTR
*       R4=C
*       R0=C
*       LC(3)   34*8
*       R1=C
	GOSUB   StringTabEnd
	NIBASC  \  Jazz Flag Options:  \
	NIBASC  \ 1: Show Assembly     \
	NIBASC  \ 2: Disable Guessing  \
	NIBASC  \ 3: Non Sys-RPL Stack \
	NIBASC  \ 4: No ML Disassembly \
	NIBASC  \ 5: No Tabing Code    \
	NIBASC  \ 6: Lables on own line\
StringTabEnd
	C=RSTK
	D1=C
	C=0     A                            offset for char
	R2=C                            set current line to 0
	R0=C
	LC(2)   #22                     no of chars in line
	D=C     A
	C=0     A
LineWrite
	GOSBVL  =D0->Row1
	A=A+C   A
	D0=A
	B=0     A
	LC(3)   22

** D0  = grob write address
** D1  = char data
** D.A = # 22
** C.A = no of chars 
** B.A = x location

************* USES 4 STACK LEVELS !!!!! ***************

	GOSBVL  =$5x7

	A=R2
	LC(1)   6        done 7 lines ?
	?C=A    P
	GOYES   contl2
	A=A+1   A
	R2=A
	ASL     A
	C=A     A
	ASL     A
	C=A+C   A
*       A=R0
*       C=R1
*       C=A+C   A
*       R0=C
	GOTO    LineWrite       do next line
contl2
*******************************************************************************
**
** Initial Display is now written
**
*******************************************************************************
*       ST=0    =sFAST          set Slow mode   ONLY SLOW MODE NOW
	GOSBVL  =DisableIntr    no ON-A-F here !!!!
	GOSUB   D1->UserFlags
	R0=C                    * flags -> R0
	LC(2)   5               Test bits 5-0 (flags 6 to 1)
	D=C     A
bflp
	C=R0
	?CBIT=0 5               test bit 5
	GOYES   borisk
	C=D     A               C -> row to check
	C=C+1   A
	GOSUB   ToggleRow
	C=R0                    make sure flags are back in C
borisk  
	C=C+C   A               shift C by 1 
	R0=C                    rotate to R0
	D=D-1   A
	GONC    bflp
	
*       ?CBIT=0 =Flag1          flag 1 clear?
*       GOYES   f2              else
*       LC(2)   1               row = 1
*       GOSUB   ToggleRow       set a "tick" mark
*f2
*       ?CBIT=0 =Flag2          flag 2 clear?
*       GOYES   f4
*       LC(2)   2
*       GOSUB   ToggleRow
*f4
*       ?CBIT=0 =Flag3          flag 3 clear?
*       GOYES   f6
*       LC(2)   3
*       GOSUB   ToggleRow
*f6
*       ?CBIT=0 =Flag4          flag 4 clear?
*       GOYES   f8
*       LC(2)   4
*       GOSUB   ToggleRow
*f8
*       ?CBIT=0 =Flag5          flag 5 clear?
*       GOYES   f10
*       LC(2)   5
*       GOSUB   ToggleRow
*f10
*       ?CBIT=0 =Flag6          flag 6 clear?
*       GOYES   cont0
*       LC(2)   6
*       GOSUB   ToggleRow

*************************************************************************
**
** Flags now shown
**
*****************************************************************************
cont0   
	C=0     A
	LC(1)   =sTOP
	D=C     A               initialize & invert row 1
	GOSUB   Invert!

	GOSUB   UpdateTime
*** Start of main loop ******************************************************
main    GOSUB   delay?
	GOSBVL  =Kbd_OR
	GOC     key!            key is being pressed so don't sleep!

	SHUTDN                  no keys pressed, so go sleep

key!    GOSUB   UpdateTime

******************************************************************************
****** Main Key definitions **************************************************
******************************************************************************
	LC(2)   #B                      UpCursor
	GOSUB   keyPressed?
	GONC    key1
	GOTO    UpCursor
key1    LC(2)   #11                     DnCursor
	GOSUB   keyPressed?
	GONC    key7
*       GONC    key2
	GOTO    DnCursor
*key2   LC(2)   #31                     key [+]          \
*       GOSUB   keyPressed?                               \
*       GONC    key3                                       \
*       ST=1    =sFAST                  set fast mode       \
*key3   LC(2)   #2C                     key [-]              \
*       GOSUB   keyPressed?                                   NOT USED
*       GONC    key6                                         /
*       ST=0    =sFAST                  set slow mode       /
*key6    LC(2)   #1A                     [+/-]              
*        GOSUB   keyPressed?                               
*        GONC    key7                                     
*        GOTO    Toggle                                  
*key6    LC(2)   #1D                     [DROP] --> exit
*	GOSUB   keyPressed?
*	GONC    key7
*	GOTO    exit
key7    LC(2)   #19                     [ENTER] --> toggle 
	GOSUB   keyPressed?
        GONC    exitkey
	GOTO    Toggle
*       GOC     exit
exitkey        
        GOSBVL  =AINRTN
        ?ABIT=1 15                      [ATTN] pressed?
        GOYES   exit
        GOTO    main                    start main loop again

exit    GOSBVL  =Kbd_OR
	GOC     exit                    key still pressed?
	GOSBVL  =AllowIntr
	GOVLNG  =GETPTRLOOP

***** keyPressed? ************************************************************
* Checks if a key specified in C.B is down
******************************************************************************
keyPressed?
	A=C     B
	GOVLNG  =ThisKeyDown?             since this is an absolute jump
*                                       to an address that does a RTN,
*                                       it will return to the routine that
*                                       called keyPressed?

UpdateTime
	D1=(5)  =TIMER2
	A=DAT1  A                       get current time
	R4=A                            store new value in timer
	RTN
******************************************************************************
*
*
******************************************************************************
delay? 
*       ?ST=1   =sFAST                   fast mode on?
*       RTNYES                          then do nothing
	A=R4                            get old delay
	LC(5)   #433
	A=A-C   A                       convert to correct amount
	D1=(5)  =TIMER2
delayLp C=DAT1  A                       get time
	?C>A    A                       NOT waited enough?
	GOYES   delayLp
	RTN                             ok, continue

***** Key Definitions *********************************************************
*
*
******************************************************************************* 
UpCursor
*       C=D     A                       get current row
	C=0     A
	LC(1)   =sTOP
	?C=D    B                       are we at the top ?
	GOYES   resetUp
	C=D     A
	GOSUB   Invert!
	D=D-1   A
	C=D     A                       get old value
*       C=C-1   A
*       D=C     A                       put old value+1 back
	GOSUB   Invert!                 set new row
	GOTO    main
resetUp GOSUB   Invert!                 clear old row
	C=0     A
	LC(1)   =sBOTTOM                make new row = row 7
	D=C     A
	GOSUB   Invert!                 set new row
	GOTO    main

DnCursor
*       C=D     A                       get current row
*       LA(2)   =sBOTTOM
	C=0     A
	LC(1)   =sBOTTOM
	?C=D    B                       are we at the bottom?
	GOYES   resetDn
	C=D     A
	GOSUB   Invert!
	D=D+1   A
	C=D     A                       get old value
*       C=C+1   A
*       D=C     A                       put old value+1 back
	GOSUB   Invert!                 set new row
	GOTO    main
resetDn GOSUB   Invert!                 clear old row
	C=0     A
	LC(1)   =sTOP                   make new row = top row
	D=C     A
	GOSUB   Invert!                 set new row
	GOTO    main

***** Invert! ******************************************************************
* inverts the screen display row given by C.A ( =row ) from 1 -> 7
* USES : A.A  B.A  C.A  D0  P
* CALLS: D0->Row1 
*******************************************************************************
Invert!
	C=C-1   A       
	CSL     A        \
	B=C     A          Multily by #110
	CSL     A        /
	C=C+B   A       /
	GOSBVL  =D0->Row1
	A=A+C   A
	D0=A
	LC(2)   #10
writelp
	A=DAT0  W
	A=-A-1  W
	DAT0=A  W
	D0=D0+  16
	C=C-1   B
	GONC    writelp
	RTN

*       A=C     A
** NOTE : 34 Nibs of data per row of pixels
*       LC(5)   34*8
*       GOSBVL  =MUL#           calculate offset C.A * A.A -> B.A
*       GOSBVL  =D0->Row1       D0 = @ row1 in screen grob
*       A=A+B   A
*       D0=A
*       CD0EX
*       C=C+B   A               add offset
*       CD0EX                   D0 is address in ABUFF at beginning of line
*       P=      16-8            8 rows, so at loop exit, P= 0
*writelp C=DAT0  W               
*       C=-C-1  W
*       DAT0=C  W               invert 16 nibs
*       D0=D0+  16
*       C=DAT0  W
*       C=-C-1  W
*       DAT0=C  W               invert next 16 nibs
*       D0=D0+  16
*       C=DAT0  B
*       C=-C-1  B
*       DAT0=C  B               invert last 2 nibs in pixel row
*       D0=D0+  2
*       P=P+1
*       GONC    writelp         at exit, P= 0 --> neat huh?
*       RTN

**** D1->UserFlags ***********************************************************
* puts Address of UserFlags into D1
* trashes C.B
******************************************************************************
D1->UserFlags
	C=0     A
	D1=(5)  #12660                  base address of RAM (ie S/SX or G/GX)
	C=DAT1  B
	?CBIT=1 3               
	GOYES   gx
	D1=(5)  =UserFlags              SX: user flags  
	GOTO    sx
gx      D1=(5)  =G_UserFlags
sx      C=DAT1  B
	RTN

**** wait ********************************************************************
* waits until there are no more keys being pressed, then restarts main loop
******************************************************************************
wait    GOSBVL  =Kbd_OR
	GOC     wait                    key still pressed?
	GOTO    main

**** Toggle ******************************************************************
* Toggles the flag highlighted by the scroll bar and updates display
* Don't have to worry about speed, because the user is pressing the key
******************************************************************************
Toggle
	GOSUB   D1->UserFlags
	B=C     B
	C=D     B               get the current highlighted bar
	C=C-1   B               adjust the value to a bit number

* A.A = mask
* B.A = flags
* C.A = loop counter    
* we now toggle the bit in B.A given in C.B by xor'ing it with a mask

	A=0     B
	C=C-1   B               zero trap
	GOC     togAxorC        
	LA(1)   1               A.1 = 0001 b  (mask)
	C=C-1   B
	GOC     togAxorC        initial test
toglp   A=A+A   B               same as ASLB.F  A --> shift the mask left 1 bit
	C=C-1   B               dec. counter
	GONC    toglp
togAxorC
	C=B     B               put mask in C and call xor
	GOSUB   AxorC
	DAT1=A  B               write flag data back with changed flag

** ok, flag is updated, now it is time to update the display

*       C=D     A
*       GOSUB   Invert!         kill scroll bar (otherwise xor won't work)
	C=D     A               get current row
	C=C-1   A               initialize value
	GOSUB   ToggleRow       toggle row
*       C=D     A
*       GOSUB   Invert!         replace scroll bar
	GOTO    wait

**** AxorC *******************************************************************
* Does A.A xor C.A -> A.A
******************************************************************************
AxorC   B=A     B
	B=B&C   B
	A=A!C   B
	A=A-B   B
	RTN

**** ToggleRow ***************************************************************
* Toggles the row given by C.A
* constructs a mask and XORs the screen block with it
******************************************************************************
ToggleRow
	CSL     A
	B=C     A
	CSL     A
	C=C+B   A
*       A=C     A
*       LC(5)   34*8
*       GOSBVL  =MUL#
	GOSBVL  =D0->Row1       D0 = @ row1 in screen grob
*       A=A+B   A
	A=A+C   A
	D0=A
*       CD0EX
*       C=C+B   A               add offset      
*       CD0EX                   D0 is address in ABUFF at beginning of line
	LCHEX   000002070D181000                check mark
*       LCHEX   00040F1F0F040000                star thingie (don't use)
	P=      16-8
togrwlp A=DAT0  B
	GOSUB   AxorC
	DAT0=A  B
	D0=D0+  16
	D0=D0+  16
	D0=D0+  2
	CSR     W
	CSR     W
	P=P+1
	GONC    togrwlp
*       C=0     A
	C=DAT1  B
	RTN
ENDCODE
