	TITLE  Jazz Scroll v1.2
******************************************************************************
******************************************************************************
**
** Name: Jazz Scroll v1.2
**
** Category: Display
**
** Abstract: displays a choice of the flags affecting Jazz
**
** Entry:    RPL inner loop
**
** Exit:     RPL inner loop 
**
** Error Exits: none
**
** Alters: CPU : most
**         RAM : UserFlags 1->6 & DA2
**
** Calls:    SAVPTR     : saves RPL registers
**           GETPTRLOOP : restores RPL registers and continues RPL
**	     D0->Row1	: D0, A.A = start of ABUFF data
**	     DisableIntr: disables interupts
**	     EnableIntr	: enables interupts
**	     AINRTN	: does A=IN  RTN on an even address (hardware bug)
**	     Kbd_OR	: returns carry if key down
**	     ThisKeyDn?	: returns carry if key specified by C.B is down
**	     WIPEOUT	: clears C.A nibs starting at D1
**	     $->3x5	: writes small font
**           
** Stack Levels: .....
**
**     Date     Prog             Modification
**   --------   ----   -------------------------------------------------------
**   5-08-95   RHS    rewrote entirely
**============================================================================
ASSEMBLE
	NIBASC	/HPHP48-X/
** Unsupported entry points
$->3x5		EQU	#12223	
WIPEOUT		EQU	#0675C		
Kbd_OR		EQU	#00E0B
ThisKeyDn?	EQU	#00C8D
aUserFlags	EQU	#537D7	!! unsupported !! pointer to =UserFlags
** Equates *******************************************************************
sTOP		EQU	0	top flag
sBOTTOM		EQU	5	bottom flag
RPL

** Register Usage **
** R4.A = ABUFF start
** R4.S = write_loop loop counter (during initial screen write)
** R3.W = timeout
** R2.B = flags
** D.B	= current highlighted row

CODE
	GOSBVL	=SAVPTR
	GOSBVL	=D0->Row1
	LC(5)	34*16		offset to start of DA2a
	A=A+C	A
	D1=A			start address to WIPEOUT
	LC(3)	34*2
	A=A+C	A
	R4=A.F	A		offset into ABUFF for EVERYTHING to happen
	LC(3)	34*40		size of DA2
	GOSBVL	=WIPEOUT	clear DA2
	GOSUB	end$
** Offset table to strings
	REL(3)	$0		
	REL(3)	$1
	REL(3)	$2
	REL(3)	$3
	REL(3)	$4
	REL(3)	$5
** len (2 nibs)
** String data
$0	CON(2)	18
	NIBASC	\ASS Report Mode On\
$1	CON(2)	18
	NIBASC	\DIS Guess Mode Off\
$2	CON(2)	19
	NIBASC	\SSTK Not System-RPL\
$3	CON(2)	20
	NIBASC	\SASM Dissasembly Off\
$4	CON(2)	21
	NIBASC	\No TABS in DIS Output\
$5	CON(2)	22
	NIBASC	\Put Labels on Own Line\
** 6 lines of text to write **
end$	C=RSTK
	R3=C.F	A
	C=0	S
	R4=C.F	S		zero loop counter 
** Entry : R3 = start of next line
** count up from zero for write loop
ShowLp	C=R3.F	A
	B=0	A
	LA(5)	34*6
	C=C-1	S
	GOC	endshf		catch zero
shiftlp	B=B+A	A
	C=C+CON	A,3
	C=C-1	S
	GONC	shiftlp
endshf	D1=C
	A=0	A
	A=DAT1	X		REL offset
	C=C+A	A
	D1=C			read addr
	A=R4.F	A
	A=A+B	A		add row offset
	D0=A			D0 -> start write address
	D0=D0+	5		offset to make space for flags
	C=0	A
	C=DAT1	B		len $
	D1=D1+	2
	B=0	B		col offset
	LA(5)	34		row width
	GOSBVL	=$->3x5
* Check loop counter
	C=R4.F	S
	C=C+1	S
	LA(1)	(=sBOTTOM)+1
	ASRC
	?A=C	S		done all the rows yet ?
	GOYES	EndShLp
	R4=C.F	S
	GOTO	ShowLp
** Display now written **
EndShLp	
	GOSUB	D1->Flags
	C=0	A
	C=DAT1	B
	R2=C.F	A		extra copy for when we want to change them!
	R0=C.F	B		flags -> R0
	LC(2)   6-1		Test bits 5-0 (flags 1 to 6)
	D=C     A
bitLoop	C=R0.F	B
	?CBIT=0 5		test bit 5 (flag 6)
	GOYES   bitclr?
	C=D     A		C -> row to check
	GOSUB   ToggleRow
	C=R0                    make sure flags are back in C
bitclr?	C=C+C   A		shift C by 1 
	R0=C			rotate to R0
	D=D-1   A
	GONC    bitLoop
** "Tick" marks now written
	LC(2)	=sTOP
	D=C	B		D.B is current line
	GOSUB	Invert!
	GOSBVL  =DisableIntr    no ON-A-F here !!!!
	GOSUB   UpdateTime
*** Start of main loop *******************************************************
main    GOSUB   delay?
	GOSBVL  =Kbd_OR
	GOC     key!            key is being pressed so don't sleep!
	SHUTDN                  no keys pressed, so go sleep
key!    GOSUB   UpdateTime
******************************************************************************
****** Main Key definitions **************************************************
******************************************************************************
	LC(2)   #B              UpCursor
	GOSUB   keyPressed?
	GONC    key1
	GOTO    UpCursor
key1    LC(2)   #11             DnCursor
	GOSUB   keyPressed?
	GONC    key2
	GOTO    DnCursor
key2	LC(2)   #1A             [+/-]	--> toggle highlighted flag
	GOSUB   keyPressed?                               
	GONC    key3
	GOTO    Toggle
key3	LC(2)   #19             [ENTER]	--> Save flags and exit
	GOSUB   keyPressed?
	GONC    exitkey
	GOC     Save&Exit
exitkey	GOSBVL  =AINRTN
	?ABIT=1 15              [ATTN]	--> exit
	GOYES   STKexit
	GOTO    main            start main loop again
Save&Exit
	GOSUB	D1->Flags
	A=R2.F	A
	DAT1=A	B		write new flags
STKexit	GOSBVL  =Kbd_OR
	GOC	STKexit		key still pressed?
	GOSBVL  =AllowIntr
	GOVLNG  =GETPTRLOOP
**** Toggle ******************************************************************
* Toggles the current row
******************************************************************************
Toggle	C=D	B
	LA(2)	1
	C=C-1	B
	GOC	endlp
tlp	A=A+A	B
	C=C-1	B
	GONC	tlp
endlp	C=R2.F	B
	GOSUB	AxorC
	R2=A.F	B
	C=D	B
	GOSUB	ToggleRow	change the display
tlp2	GOSBVL  =Kbd_OR		wait for the user to get off the key
	GOC	tlp2		key still pressed?
	GOTO	main

***** keyPressed? ************************************************************
* Checks if a key specified in C.B is down
******************************************************************************
keyPressed?
	A=C     B
	GOVLNG  =ThisKeyDn?

UpdateTime
	D1=(5)  =TIMER2
	A=DAT1  A                       get current time
	R3=A                            store new value in timer
	RTN
delay? 	A=R3                            get old delay
	LC(5)   #433
	A=A-C   A                       convert to correct amount
	D1=(5)  =TIMER2
delayLp C=DAT1  A                       get time
	?C>A    A                       NOT waited enough?
	GOYES   delayLp
	RTN                             ok, continue

***** Key Definitions ********************************************************
* Up and Down Arrow keys
******************************************************************************
UpCursor
	LC(2)   =sTOP
	?C=D    B		are we at the top ?
	GOYES   resetUp
	GOSUB   Invert1		turn off old highlight bar
	D=D-1   B
	GOTO	Inv&Rst		set new row and start main loop again
resetUp GOSUB   Invert!		turn off old highlight bar
	LC(2)   =sBOTTOM	make new row the bottom
	GOTO	Inv&UR		update D.B, invert row and restart
DnCursor
	LC(2)   =sBOTTOM
	?C=D    B		are we at the bottom?
	GOYES   resetDn
	GOSUB   Invert1
	D=D+1   B
Inv&Rst	GOSUB   Invert1		set new row
	GOTO    main
resetDn GOSUB   Invert!		clear old row
	LC(2)   =sTOP		make new row = top row
Inv&UR	D=C	B
	GOSUB   Invert!		set new row
	GOTO    main

**** ToggleRow ***************************************************************
* Description	: Toggles the row given by C.A
* IN  	: A.A, C.A
* OUT 	: A.A
* USES	: A.A, B.A, C.A
ToggleRow
	GOSUB	R->Addr
	D0=D0+	2
	LCHEX	02070D1810	"tick" data (reversed)
	P=	16-5
setrwlp	A=DAT0	B
	GOSUB	AxorC
	DAT0=A	B		write 2 nibs
	D0=D0+	16		\
	D0=D0+	16		 > next line
	D0=D0+	2		/
	CSR	W
	CSR	W		ditch those nibs
	P=P+1			incr. loop counter
	GONC	setrwlp
	RTNCC

**** R->Addr *****************************************************************
** Description	: calculates line write address
** IN	: C.A = row to calc write address of
** OUT	: D0 = C.A = write address, CARRY clear
** USES	: A.A, C.W, CARRY
R->Addr	CSRC
	C=0	A
	?C=0	S
	GOYES	endR
	C=C-1	S		option base 0
	LA(5)	34*6
Rlp	C=C+A	A
	C=C-1	S
	GONC	Rlp
endR	A=R4.F	A
	C=C+A	A
	D0=C
	RTN

**** D1->Flags ***************************************************************
** Description	: puts flag address in D1
** IN	: -
** OUT	: D1 = UserFlags
** USES	: D1, C.A
D1->Flags
	D1=(5)	=aUserFlags	!! unsupported !!
	C=DAT1	A
	D1=C
	RTN

**** Invert! *****************************************************************
** Description	: Inverts line given by C.A
** IN	: C.A = line number
** OUT	: line inverted
** USES	: P, C.W, CARRY, 1 stack level
Invert1	C=D	B
Invert!	GOSUB	R->Addr
	P=	16-12
InvLp	C=DAT0	W
	C=-C-1	W
	DAT0=C	W
	D0=D0+	16
	P=P+1
	GONC	InvLp
	P=	12-1
	C=DAT0	WP
	C=-C-1	WP
	DAT0=C	WP
	P=	0
	RTN

**** AxorC *******************************************************************
* Description	: Does A.B xor C.B -> A.B
* IN  	: A.B, C.B
* OUT 	: A.B
* USES	: A.B, B.B, C.B
AxorC   B=A     B
	B=B&C   B
	A=A!C   B
	A=A-B   B
	RTN
ENDCODE
