ASSEMBLE
	LISTM
RPL
**********************************************************************
* Modulname:	JAZZ
* Author:	Mika Heiskanen
* Address:	JMT 7 C 355, 02150 ESPOO, FINLAND
* Email:	mheiskan@alpha.hut.fi
*
**********************************************************************

**********************************************************************
*		Config & Message table
**********************************************************************

xROMID	3E0	( 992 )

ASSEMBLE
ROMID#	EQU #3E0
=xxCONFIG
RPL

:: [#] ROMID# TOSRRP ;

	INCLUDE msgtab.s

**********************************************************************
*		External Definitions
**********************************************************************

* display

* assmain.s

EXTERNAL	xASS
EXTERNAL	Assemble
EXTERNAL	MakeAssStat$
EXTERNAL	SetupAssOps

* dismain.s

EXTERNAL	xDIS
EXTERNAL	xDISXY
EXTERNAL	xDOB
EXTERNAL	Dob
EXTERNAL	xDISN

EXTERNAL	Diss
EXTERNAL	SetDissOps
EXTERNAL	SetDisXYOps
EXTERNAL	SetDisnOps
EXTERNAL	SetStkDis1Ops

*EXTERNAL	?DobRam

EXTERNAL	ScanLabels	( $status --> $status $labels )
EXTERNAL	ScanLabsXY	( $status --> $status $labels )
EXTERNAL	AddLabsRPL	( $labels #x #y --> $labels' )
EXTERNAL	AddLabsXY	( $labels #x #y --> $labels' )

EXTERNAL	FindObEnd	( #x --> #x #y TRUE / #x FALSE )
EXTERNAL	SkipMLN
* db.s
EXTERNAL	xDB
* sdb.s
EXTERNAL	xSDB
EXTERNAL	xSHALT
EXTERNAL	SdbStart
EXTERNAL	SdbName
EXTERNAL	SdbRomp
EXTERNAL	SdbSeco
EXTERNAL	RUI
EXTERNAL	RUIHALT
EXTERNAL	SdbMenu
EXTERNAL	SdbCheckMe
EXTERNAL	SdbDoMode
EXTERNAL	SdbThisMode
EXTERNAL	SdbFinish
EXTERNAL	SdbEval
EXTERNAL	SdbRstkDisp
EXTERNAL	RPICK
EXTERNAL	SdbD0Disp
EXTERNAL	SdbLamDisp
EXTERNAL	SdbDispLam
EXTERNAL	GetLamEnv!
EXTERNAL	GetLamEnv
EXTERNAL	SdbLoopDisp
EXTERNAL	Pad$
EXTERNAL	GetLoopEnv
EXTERNAL	SdbExec
EXTERNAL	SdbSkip
EXTERNAL	SdbDbCode
EXTERNAL	SdbSemi
EXTERNAL	SdbInOb
EXTERNAL	SdbInId
EXTERNAL	SdbInThis

EXTERNAL	SdbSstSemi
EXTERNAL	SdbSstOb
EXTERNAL	sst_rpite
*EXTERNAL	sst_decr
EXTERNAL	sst_exam
EXTERNAL	sst_rprot
EXTERNAL	sst_reval:
EXTERNAL	sst_rcola
EXTERNAL	sst_cola
EXTERNAL	sst_raddtop
EXTERNAL	sst_addtop
EXTERNAL	sst_ntrap
EXTERNAL	sst_dtrap
EXTERNAL	sst_status?

* ea.s
EXTERNAL	xEA
EXTERNAL	#>Entr
EXTERNAL	Entr>#
* rtab.s
EXTERNAL	xRTAB
EXTERNAL	xDTAB
EXTERNAL	GetRplTab
EXTERNAL	GetDisTab
EXTERNAL	RclID
* mkrtab.s
EXTERNAL	xRTB\8D
EXTERNAL	x\8DRTB
* mkdtab.s
EXTERNAL	x\8DDTB
* parmain.s
* memory.s
EXTERNAL	SG_ITE
EXTERNAL	SX?
EXTERNAL	CHECKME
EXTERNAL	TOTEMPBOT?
* ec.s
EXTERNAL	xEC
EXTERNAL	DoEC
* ed.s
EXTERNAL	xED
EXTERNAL	xTED
EXTERNAL	DoEdAt
EXTERNAL	DoEd
EXTERNAL	DoEd_ASS
EXTERNAL	DoEd_DOB
EXTERNAL	DoEd_STK
EXTERNAL	DoEd_GROB
EXTERNAL	DoEd_EC
EXTERNAL	Recall
* view.s
EXTERNAL	xVV
EXTERNAL	ViewGrob
EXTERNAL	ViewGrob!
* stk.s
EXTERNAL	xSSTK
EXTERNAL	SSTKLOOP
EXTERNAL	ModSStkKey
EXTERNAL	SysDisplay!
EXTERNAL	?DispStack!
EXTERNAL	DispStack!
EXTERNAL	DispStack1!
EXTERNAL	DispLevel!
EXTERNAL	StkDis1
EXTERNAL	JavaDis1
* istk.s
EXTERNAL	IStk
EXTERNAL	IStkDisp
EXTERNAL	?DispIStk
EXTERNAL	IStkKeys
EXTERNAL	IStkUp&Rep
EXTERNAL	IStkDn&Rep
EXTERNAL	IStkPgUp
EXTERNAL	IStkPgDn
EXTERNAL	IStkFarUp
EXTERNAL	IStkFarDn
EXTERNAL	IStkMenu
EXTERNAL	IStkDoN:
EXTERNAL	IStkMenuEd
EXTERNAL	IStkView
EXTERNAL	IStkIView
EXTERNAL	IStkEdit
EXTERNAL	IStkVisit
EXTERNAL	IStkDrop
EXTERNAL	?AdjSel/Exit!
EXTERNAL	?AdjSelPos!
EXTERNAL	ShowSel!
EXTERNAL	UnShowSel!
EXTERNAL	>SelPict!

* scanner.s

*EXTERNAL	xSC

* jazz.s itself

EXTERNAL	JazzHook
EXTERNAL	xJAZZ


**********************************************************************
*		Global Definitions
**********************************************************************

	INCLUDE	keydefs.h
ASSEMBLE
	INCLUDE	gentries.a	* Unsupported entries
	INCLUDE	gmacros.a	* Global macros
	INCLUDE	dis/disdefs.a	* DISS definitions
	INCLUDE	ass/assdefs.a	* ASS definitions
	INCLUDE	dbg/dbdefs.a	* MDB definitions
RPL
**********************************************************************
*		JAZZ Subroutines
**********************************************************************

	INCLUDE	display/ufl.h		( UFL defines )
	INCLUDE	display/display.s	( Display subroutines for ASS )
	INCLUDE	ass/ass.s		( Assembler )
ASSEMBLE
	INCLUDE	misc/safeskip.a		( SafeSkipOb )
RPL
	INCLUDE	misc/memory.s		( Memory subroutines )
	INCLUDE	dis/dis.s		( Disassembler )
	INCLUDE	dbg/db.s		( ML Debugger )
	INCLUDE	sdbg/sdb.s
	INCLUDE tab/ea.s		( EA command )
	INCLUDE	tab/rtab.s		( RTAB & DTAB )
	INCLUDE	tab/mkrtab.s		( RTAB-> and ->RTAB )
	INCLUDE	tab/mkdtab.s		( ->DTAB )
	INCLUDE	ec/ec.s			( Entries Catalog )
	INCLUDE	edit/ed.s		( ED )
	INCLUDE	edit/view.s		( VV )
	INCLUDE	stk/stk.s		( RPL Stack )
	INCLUDE	stk/istk.s		( Interactive stack )

**********************************************************************
*		JAZZ HOOKS FOR EXTERNAL LIBRARIES
**********************************************************************

**********************************************************************
* Name:		JazzHook
* Interface:	( --> { hooks } )
* Description:
*		Hidden xlib for external programs to use Jazz subroutines.
**********************************************************************
NULLNAME JazzHook
tNAME JazzHook JAZZHOOK		( Provide stable hooking mechanism )
::
  CODE
	?C<=B	A		PC <= RPL return stack? (see DOCODE end)
	GOYES	+
+	GOVLNG	=PushT/FLoop	TRUE if Jazz is covered
  ENDCODE
  case NULL{}			( NULL{} if Jazz is covered )

  {
	GetRplTab		( --> RPL.TAB )		( * Java * )
	GetDisTab		( --> DIS.TAB )		( * Java * )
	StkDis1			( ob --> $ )		( * Java * )
	JavaDis1		( ob dtab tab --> $ )	( * Java * )
  }
;

* Sample on how to call the hook:
*	( --> false | {hooks} true )
*	::
*	  "JAZZHOOK" palparse DROP	( try parsing the name )
*	  DUPTYPEROMP? NOTcsdrpfls	( fail if romp not found )
*	  EVAL DUPNULLCOMP? casedrpfls	( fail if Jazz is covered )
*	  TRUE
*	;
*
*	If true is returned then just pick the items you need from
*	the returned list.
*
*	Programmers please feel free to suggest additions to the list.

**********************************************************************
*		JAZZ UNCOVER COMMAND
**********************************************************************

* Known bug: Subdirectories are not detached
* Untested

ASSEMBLE
	CON(1)	8
RPL
xNAME JAZZ

ASSEMBLE
=G_CONFTAB	EQU #8052B *	Configuration table
*=G_ROMPTAB	EQU #809A3 *	Library table
=G_NEXTROMPID	EQU #080DA *	Get next lib from romptab as acptr
=G_ROMPARTADDR	EQU #0806D *	Return lib address as acptr
=G_REMRPLOOP	EQU #0B152 *	Delete lib referred by acptr from ROMPTAB
=ACCESSBANK01	EQU #7073F *	Port 2
=ACCESSBANK32	EQU #70894 *	Port 33
RPL

::

  CK0

* Abort if SX

  CODE
	AD0EX
	D0=(5)	=IRAM@
	C=DAT0	B
	D0=A
	C=C+C	P
	GOVLNG	=PushT/FLoop
  ENDCODE
  NOT?SEMI

* Error if no Jazz

  [#] ROMID# G_ROMPARTADDR
  NOTcase :: "Where's the Moon?" DO$EXIT ;

* Abort if Jazz not covered

  CODE
	A=DAT0	A	->acptr
	AD0EX
	D0=D0+	10
	C=DAT0	A	->access
	D0=A
	?C=0	A
	GOYES	+
+	GOVLNG	=PushT/FLoop
  ENDCODE
  ?SEMI

* Error if card 1 exists.

  CODE
	AD0EX
	D0=(5)	(=G_CONFTAB)+4
	C=DAT0	B
	D0=A
	C=C+C	P		CRY SET if card 1 readable
	GOVLNG	=PushT/FLoop
  ENDCODE
  casedrop :: "Put Jazz in card 1" DO$EXIT ;

* Error if Jazz not in port 2

  CODE
	C=DAT1	A	->acptr
	CD0EX
	D0=D0+	10
	A=DAT0	A	->access
	D0=C
	LC(5)	=ACCESSBANK01
	?A#C	A
	GOYES	+
+	GOVLNG	=PushT/FLoop
  ENDCODE
  casedrop :: "Put Jazz in port 2" DO$EXIT ;

  DROP				( Drop Jazz access pointer )

* Now remove all attachments that will be lost

   MINUSONE BEGIN
	#1+ G_NEXTROMPID
   WHILE
	DUP G_ROMPARTADDR	( jacptr #romid acptr T / jacptr #romid F )
	NOT?SEMI			( Shouldn't happen )

	CODE
		GOSBVL	=PopASavptr
		D0=A			->acptr
		D0=D0+	10		Leave alone if same port as Jazz
		A=DAT0	A
		LC(5)	=ACCESSBANK01	Leave alone if not in card 2
		?A<=C	A		or if in port 2
		GOYES	+
		LC(5)	=ACCESSBANK32
		?A>C	A
		GOYES	+
+		GOVLNG	=GPPushT/FLp
	ENDCODE
	?SEMI				( Leave it )
	DUP OFFSRRP
   REPEAT

* Now pretend we have only one port, which is visible

  CODE
	GOSBVL	=SAVPTR

* Now loop through ROMPTAB so that
*	port 2    access slot is change to zero
*	port 3-33 slots are deleted


	D0=(5)	=G_ROMPTAB
	A=DAT0	A
	B=A	A			B[X] = libraries to check
	D0=D0+	3
	D1=(5)	(=G_ROMPTAB)+3		->output

-	B=B-1	X
	GOC	romptabdone		Done changes
	A=DAT0	W			Assume this slot will be copied
	DAT1=A	W
	D0=D0+	3+5			->access address
	D1=D1+	3+5
	A=DAT0	A
	LC(5)	=ACCESSBANK32
	?A>C	A
	GOYES	++			> card 2 - leave it
	LC(5)	=ACCESSBANK01
	?A<C	A
	GOYES	++			< card 1 - leave it
	?A=C	A			Port 2 ?
	GOYES	+			Yes - just clear access address
	D1=D1-	16
	GONC	++			No - must be deleted then
+	A=0	A
	DAT1=A	A
++	D0=D0+	8
	D1=D1+	8
	GONC	-			Loop until end of tables

* Now fix the number of libraries

romptabdone
	LC(5)	=G_ROMPTAB
	D0=C
	AD1EX
	A=A-C	A			total mem
*	A=A-CON	A,3			-3 for lib count
	ASR	A			16 nibble slots
	DAT0=A	X

* Now pull the Jazz port to make sure it is on top

	D0=(5)	(=ACCESSBANK01)+2	->"D0=(5) #pull"
	C=DAT0	A			->pull
	D0=C
	C=DAT0	B			pull it

* Now force number of ports to be one

	D0=(5)	(=G_CONFTAB)+4+2+2	->#banks
	LC(2)	1			1 bank only
	DAT0=C	B

* Fix CONFTAB CRC
* Not necessary, since TurnOff detects the trick anyway

	ST=0	15
	GOSBVL	=COMPCONFCRC
	DAT0=C	4
	GOSBVL	=AllowIntr

* Now unconfigure the bank switch device to avoid losing Jazz
* Bad: Causes # and "" keys to crash

*	LC(5)	#7F000
*	UNCNFG

	GOVLNG	=GETPTRLOOP
  ENDCODE

;
**********************************************************************
