
* This general lifting program exhibits both linear and quadratic lifting
* as options. Linear lifting is chosen by setting user flag 2.
*
* The decision was to discard quadratic lifting based on experiments.
* The overhead from lifting the basis was usually too great to warrant
* the extra complexity.


*---------------------------------------------------------------------
* Desc:		Lift factorization mod p to factorization mod p^k
*		where p^k exceeds the factor bound for succesful
*		true factor extraction.
* Stack:	( --> )
* Notes:	Assumes UFactor lambda variables
*---------------------------------------------------------------------
NULLNAME LiftGeneral
::
  ( * Calculate bound * )
  ufac_P
  ONE TestUserFlag ITE Mignotte Beauzamy
  ufac_bf!

  "Lifting " ufac_r #>$ &$ DISPROW5
  ONE TestUserFlag ITE "Mg " "Bz " ufac_bf Z>S &$ DISPROW6

  ( * Abort if no lifting is needed * )

  ufac_bf ufac_p ZNLT? ?SEMI

  "Partial fractions" DISPROW7

  ( * Partial fraction expansion of 1/P * )

  ufac_Lfp INNERCOMP				( u1 .. un #n )
  HXS 2 10 SWAP ONE_DO (DO)			( wi-1 .. u1 .. un-i )
      ufac_p QMulMod				( wi-1 .. u1 .. wi )
      DUP ISTOP-INDEX #2+UNROLL			( wi wi-1 .. u1 .. )
  LOOP
  2DROP						( wn-1 .. w2 w1 )

  HXS 2 10 ufac_q!				( q=1 )
  ufac_r ONE_DO (DO)
      ufac_Lfp INDEX@ NTHCOMPDROP
      2DUPSWAP ufac_p QGcdExMod
      ufac_q ufac_p QMulMod
      ROT ufac_p QDivMod SWAPDROP UNROT
      ufac_q ufac_p QMulMod
      SWAP ufac_p QDivMod ufac_q! DROP
      ufac_r #1- UNROLL
  LOOP
  ufac_q ufac_r UNROLL				( vn .. v1 )

  ( * Linear lifting loop * )

  ufac_p DUPDUP ufac_po! QMul ufac_pj!		( po=p ; pj=p^2 )

  BEGIN
      "pj " ufac_pj Z>S &$ DISPROW7

      ( Update lcoeff[u1] to be lcoeff[P] mod pj )

      ufac_Lfp INNERCOMP			( u1 .. un #n )
      ufac_Lfp CARCOMP INNERCOMP		( u1 .. un #n Meta )
      ufac_P CARCOMP ufac_pj QMod		( u1 .. un #n Meta lc' )
      OVER #1+UNROLL				( u1 .. un #n lc Meta' )
      {}N SWAPDROP				( u1 .. un #n u1' )
      OVER #1+UNROLL				( u1 u1' .. un #n )
      {}N ufac_Lfp! DROP			(  )

      ( Calculate t = P-u1*..*un mod pj / po )

      ufac_P					( P )
      ufac_Lfp INNERCOMP ONE_DO (DO)
         ufac_pj QMulMod			( P u1 .. un-i*..*un )
      LOOP
      ufac_pj QSubMod				( P-u1*..*un )
      ufac_po QDiv ufac_t!

      ( Lift the factors )
      ( If t is zero then all adjustments are zero?? )

       ufac_r #1+_ONE_DO (DO)
             "Lift u[" INDEX@ #>$ &$ "]" &$ DISPROW7
             ufac_Lfp INDEX@ NTHCOMPDROP	( ui )
             INDEX@ #2* PICK			( ui vi )
             ufac_t ufac_p QMulMod		( ui vi*t_p )
             OVER ufac_p QDivMod SWAPDROP	( ui rem[ui,vi*t] )
             ufac_po QMul			( ui po*rem[ui,vi*t] )
             ufac_pj QAddMod			( ui' )
       LOOP

       ufac_r {}N ufac_Lfp!			( Update list of factors )

       ( Now choose how to handle the last step in linear vs quadratic  )
       ( We can implement a test here which would switch from quadratic )
       ( to linear lifting but not vice versa. No quadratic lift steps  )
       ( at all is allowed, and recommended if bf is very small..       )
       ( Maple: Quadratic lifting all the way?                          )
       ( MuPAD: if pj*p^3 > bf then switch to linear                    )
       (        for some reason it won't update p=po but uses po as the )
       (        modulo in ui lifting anyway. Will have to think this    )
       (        through, but it seems strange to me at the moment..     )

*      ufac_bf ufac_pj ufac_pj QMul po QMul ZNLT?
        
       TWO TestUserFlag ITE
       ::					( * Linear lifting * )
          ufac_pj ufac_po!			( po=pj )
          ufac_pj ufac_p QMul ufac_pj!		( pj=pj*p )
       ;
       ::					( * Quadratic lifting * )
          ufac_bf ufac_pj ZNLT? case		( Avoid lifting vi if done )
          :: ufac_pj ufac_po!			( po=pj   )
             ufac_pj ufac_p!			( p=pj    )
* NONEED     ufac_pj DUP QMul ufac_pj!		( pj=pj^2 )
          ;

          ( This one is expensive, involves product of all uj except ui. )
          ( We use P/ui instead, but it's still expensive.               )

          "Quadratic lift" DISPROW7
          ufac_P ufac_pj QMod HXS 1 0		( Ppj sum=0 )
          ufac_r #1+_ONE_DO (DO)
             INDEX@ #2+PICK 3PICK		( Ppj sum vi Ppj )
             ufac_Lfp INDEX@ NTHCOMPDROP	( Ppj sum vi Ppj ui )
             ufac_pj QDivMod DROP		( Ppj sum vi quo[Ppj,ui] )
             ufac_pj QMulMod ufac_pj QAddMod	( Ppj sum' )
          LOOP
          HXS 2 10 ROTDROPSWAP			( 1 sum )
          ufac_pj QSubMod			( 1-sum )
          ufac_po QDiv ufac_t!			( t = [1-sum]/po )

          ( If t is zero then all adjustments are zero?? )
          ufac_r #1+_ONE_DO (DO)
             "Lift v[" INDEX@ #>$ &$ "]" &$ DISPROW7
             DUP				( vn .. v2 v1 v1 )
             ufac_t ufac_po QMulMod		( vn .. v2 v1 v1*t )
             ufac_Lfp INDEX@ NTHCOMPDROP	( vn .. v2 v1 v1*t u1 )
             ufac_po QDivMod SWAPDROP		( vn .. v2 v1 rem[v1*t,u1] )
             ufac_po QMul ufac_pj QAddMod	( vn .. v2 v1' )
             ufac_r UNROLL			( v1' vn ... v2 )
          LOOP
          
          ufac_pj ufac_po!			( po=pj   )
          ufac_pj ufac_p!			( p=pj    )
          ufac_pj DUP QMul ufac_pj!		( pj=pj^2 )
       ;

      ufac_bf ufac_po ZNLT?			( bf<po ? )

  UNTIL

  ( Drop vi from stack )

  ufac_r NDROP
;
**********************************************************************
