**********************************************************************
* Desc:		Fermat factorization method for short odd integers
* Stack:	( Z --> Z1 Z2 )
* Notes:
*		X^2-Y^2 = N	==> N=(X-Y)(X+Y)
*
*		Extremely slow for large N.
*
* Idea:		x+=1 : x^2-y^2 += +2x+1
*		y+=1 : x^2-y^2 -= -2y-1
**********************************************************************
CODE
		GOSUB	POPZ		A[W] = N

		B=0	W
		B=B+1	W		X=1
		C=B	W		Y=1

ferloop1	A=A-B	W
		GOC	+
		B=B+CON	W,2		X += 2
		?A#0	W
		GOYES	ferloop1
		GONC	ferfound

+		B=B+CON	W,2		X += 2
ferloop2	A=A+C	W
		GOC	+
		C=C+CON	W,2		Y += 2
		GONC	ferloop2
+		C=C+CON	W,2
		?A#0	W
		GOYES	ferloop1

ferfound
*		C=C-1	W		Not necessary due to next
		CSRB			(X-1)/2
*		B=B-1	W
		BSRB			(Y-1)/2
		A=B	W
		A=A-C	W		sum
		C=C+B	W		diff
		R4=C
		GOSUB	PUSHZ
		A=R4
		GOSUB	PUSHZ
		GOVLNG	=GETPTRLOOP
*---------------------------------------------------------------------
PUSHZ		P=	15
-		?A#0	P
		GOYES	+
		P=P-1
		GONC	-
+		P=P+1
		GOSBVL	=PUSHhxs
		GOVLNG	=SAVPTR
*---------------------------------------------------------------------
POPZ		GOSBVL	=PopASavptr
		D0=A
		D0=D0+	5
		A=0	W
		C=DAT0	A
		D0=D0+	5
		C=C-CON	A,7
		RTNC			CS: Zero
		P=C	0
		A=DAT0	WP
		P=	0
		RTN
ENDCODE
**********************************************************************
