EXTERNAL xSYLVESTER	( symb1 symb2 var --> MA )

EXTERNAL AA2RR{}	( symb1 symb2 var/list --> L Q1 R1 Q2 R2 )
EXTERNAL SymSylvester	( symb1 symb2 var --> MA )
EXTERNAL NDUP0
EXTERNAL OutSylv

**********************************************************************
*		Programs
**********************************************************************

**********************************************************************
* Name:		xSYLVESTER
* Desc:		Calculate sylvester matrix of two symbolics
* Stack:	( symb1 symb2 var --> MA )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME SYLVESTER
::
  CK3&Dispatch
    #AAA	:: FastLib SymSylvester ;
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		AA2RR{}
* Desc:		Convert symbolics to rationals with given ordering
* Stack:	( symb1 symb2 var/list --> L Q1 R1 Q2 R2 )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME AA2RR{}
::
  DUPTYPELIST? ?SKIP ONE{}N
  3PICK3PICK XAdd
  SWAP PVars{}
  ROTOVER A2R RCanno
  4ROLL 4PICK A2R RCanno
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		SymSylvester
* Desc:		Calculate Sylvester matrix of two symbolics
* Stack:	( symb1 symb2 var --> MA )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME SymSylvester
::
  AA2RR{}					( L Q1 R1 Q2 R2 )

* Check input

  4PICK DUPTYPELIST? NcaseTYPEERR
  LENCOMP DUP#0=case SETTYPEERR #1-		( L Q1 R1 Q2 R2 n1 )

  4ROLL DUPTYPELIST? IT
  :: INNERCOMP #1= NcaseTYPEERR ;		( L Q1 Q2 R2 n1 c1 )

  4PICK DUPTYPELIST? NcaseTYPEERR
  LENCOMP DUP#0=case SETTYPEERR #1-		( L Q1 Q2 R2 n1 c1 n2 )

  4ROLL DUPTYPELIST? IT
  :: INNERCOMP #1= NcaseTYPEERR ;		( L Q1 Q2 n1 c1 n2 c2 )

* Create array

  ' NULLLAM SEVEN NDUPN DOBIND

  2GETLAM ZERO_DO (DO)
	INDEX@ NDUP0
	6GETLAM 3GETLAM OutSylv
	ISTOP-INDEX #1- NDUP0
  LOOP

  4GETLAM ZERO_DO (DO)
	INDEX@ NDUP0
	5GETLAM 1GETLAM OutSylv
	ISTOP-INDEX #1- NDUP0
  LOOP

  4GETLAM 2GETLAM #+ DUP NULL$			( MM )

  MMtrim

  7GETLAM TWO MINUSONE SUBCOMP MM2MA		( MA )

  ABND
;

*---------------------------------------------------------------------
* Name:		NDUP0
* Stack:	( #n --> Z0 Z1 ... Z0 Z1 )
*---------------------------------------------------------------------
NULLNAME NDUP0
::
  DUP#0=csDROP
  ZERO_DO (DO)
     HXS 1 0 HXS 2 10
  LOOP
;

*---------------------------------------------------------------------
* Name:		OutSylv
* Stack:	( Q1 Q2 --> q11 Q2 q12 Q2 ... )
*---------------------------------------------------------------------
NULLNAME OutSylv
::
  SWAP ZERO
  BEGIN
	NEXTCOMPOB
  WHILE
	4UNROLL 3PICK 4UNROLL
  REPEAT
  2DROP
;

**********************************************************************


