**********************************************************************
* Desc:		Williams p+1 factorization method
* Stack:	( Z --> Z1 Z2 %loops )
*		or % or $
* Notes:
*		This works well if p+1 has only small factors
*
*		See UBasic programs by Malm
*
*		This is Jazz source code
*
**********************************************************************

DEFINE Z2	HXS 2 20

* Upper bound for factor of p+1

DEFINE UBnd	2000

* Gcd interval (gcd's are traded for modulo multiplications)

DEFINE Cc	20

::
  CK1NOLASTWD
  FastLib CK1Z			( --> Z )
  HXS 2 30			( P = 3 )
  NULLHXS			( Vs )
  NULLHXS			( Vb )
  ZERO				( I )
  NULLHXS			( Iz )
  {{ N P Vs Vb I Iz }}

  BEGIN
	I UBnd #<
	P Z2 QSub N ZGcd ZIsOne?
	AND
  WHILE
  ::
    Cc #1+_ONE_DO
	I #1+ I!
	I #>$ DISPROW1
	P Vs!				( Vs=P )
	P P QMul Z2 N ModSub Vb!	( Vb = P*P-2 @N )
	I #>Z ZBits SWAP Iz!		( Iz = I )
	ZERO_DO
		?ATTNQUIT
		Iz ISTOP-INDEX #1- ZBit?
		SWAPDROP ITE
		::
			Vs Vb QMul P N ModSub Vs!	( Vs = Vs*Vb-P @N )
			Vb Vb QMul Z2 N ModSub Vb!	( Vb = Vb*Vb-2 @N )
		;
		::
			Vs Vb QMul P N ModSub Vb!	( Vb = Vs*Vb-P @N )
			Vs Vs QMul Z2 N ModSub Vs!	( Vs = Vs*Vs-2 @N )
		;
	LOOP
	Vs P!				( P=Vs )
   LOOP			
  ;
  REPEAT
  P Z2 QSub N ZGcd		( gcd[P-2,N] )
  N OVER QDiv
  I UNCOERCE
  ABND
;
**********************************************************************









