	STITLE	ALG48 TEST Library
**********************************************************************
*		Library Specifics
**********************************************************************

** ROMID

xROMID 39A ( 922 )
ASSEMBLE
=TESTROMID	EQU #39A
RPL

** CONFIG

ASSEMBLE
=NEWcfg
RPL
:: [#] TESTROMID TOSRRP ;

** MESSAGES
ASSEMBLE
=NEWmsg
RPL

** EXTERNALS

EXTERNAL xRINT2
EXTERNAL RatInt2  	( sym var -> sym' )
EXTERNAL AddVar		( Q --> Q+ )
EXTERNAL RemCoeff	( P[x,y] Q[y] --> P'[x,y] )
EXTERNAL EEA		( a b --> s1 s2 t1 t2 )

EXTERNAL xRESULTANT	( symb1 symb2 var --> symb' )
EXTERNAL Resultant	( a b --> Lm |res| )

EXTERNAL xROOTS		( symb var --> Lf )
EXTERNAL Roots		( P Lvars --> Meta )
EXTERNAL RootsIrred	( P --> Meta )
EXTERNAL Roots1		( P --> root ONE )
EXTERNAL Roots2		( P --> root1 root2 TWO )
EXTERNAL Roots3		( P --> root1 root2 root3 THREE )
EXTERNAL Roots4		( P --> root1 root2 root3 root4 FOUR )
EXTERNAL QSqrt		( Q --> Qint Qroot )
EXTERNAL RootFactor	( Q --> Lf )

EXTERNAL xADER		( sym var --> sym' )
EXTERNAL DeriveSym	( sym var --> sym' )
EXTERNAL DeriveMeta	( Meta var --> Meta' )
EXTERNAL Derive		( Meta --> Meta' )
EXTERNAL DerEqu
EXTERNAL DerTrig	( Meta --> Meta&factor )
EXTERNAL DerInvTrig	( Meta --> Meta&factor )
EXTERNAL DeriveOn	( Meta --> Meta' )
EXTERNAL DeriveOff	( Meta --> Meta' )
EXTERNAL Constant?	( Meta --> Meta flag )
EXTERNAL doneg
EXTERNAL do+
EXTERNAL do-
EXTERNAL do*
EXTERNAL do/
EXTERNAL dosq
EXTERNAL dopow
EXTERNAL do2*
EXTERNAL do1-
EXTERNAL doconj

**********************************************************************
*		Unsupported Entries
**********************************************************************

* From algrsymb.s

DEFINE Rvars@	3GETLAM
DEFINE Rmain@	2GETLAM

ASSEMBLE
=derive		EQU #60E8C	* lam&1 used by MATCH commands
=xLNP1		EQU #1BA8C
=xEXPM		EQU #1BAC2
=xARG		EQU #1B2DB
=xSUM		EQU #1F2C9
=unroll2ND	EQU #5EBDB
=DEG?		EQU #53BC9
=DUP#2+PICK	EQU #5FC24
=putop+		EQU #5BC5D
=putop-		EQU #5BC8A
=putop*		EQU #5BCB7
=putop/		EQU #5BCE4
RPL


**********************************************************************
*		Programs
**********************************************************************

**********************************************************************
* Name:		xRINT
* Desc:		
* Stack:	
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME RINT2
::
  CK2&Dispatch 
    realidnt	:: FastLib XMul ;
    reallam	:: FastLib XMul ;
    symidnt	:: FastLib RatInt2 ;
    symlam	:: FastLib RatInt2 ;
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		RatInt2
* Desc:		Integral of a rational symbolic (w.r.t main var)
*		using Rothstein/Trager method with Lazaard/Rioboo
*		improvement
* Stack:	( sym var -> sym' )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

DEFINE LS@ 5GETLAM
DEFINE LR@ 4GETLAM

NULLNAME RatInt2
::
  RSimVars UNROT			( v P Q )

  ( *** add check for dependence on main var in other variables *** )

  ( * split integral of P/Q using Horowitz method * )

  Horowitz				( v R1 R2 a b  )
  2SWAP 5PICK R2A			( v a b ar )
  4UNROLL 				( ar v a b )

  ( * done if no logaritmic part * )

  OVER QIsZero? case2drop DROP		( -> ar )

  ( * compute LR = { R1[z] .. Rk[z] } the square-free * )
  ( * factorization of R[z]=res[b,a-zb']              * )

  DUP AddVar				( ar v a b b+ )
  ROT AddVar				( ar v b b+ a+ )
  ROT PDer AddVar			( ar v b+ a+ b+' )
  TWO ONE MkSplP			( ar v b+ a+ b+' z )
  QMul QSub				( ar v b+ a-z*b' )
  Resultant				( ar v LS R )
  PPP DROP				( ar v LS ppR )
  PSQFF					( ar v LS LR )

  ( * process nontrivial Ri[Z]'s * )

  ROT ZERO 				( ar LS LR vars #main )
  FOUR DUP CACHE			( ar )
  LR@ LENCOMP				( ar k )
  #1+_ONE_DO (DO)			( ar )
    ::
       LR@ INDEX@ NTHCOMPDROP		( ar Ri )
       DUPTYPELIST? NOTcaseDROP		( continue if Ri trivial factor )

       ( * Get Si[x,z] = remainder of degree i * )
       ( * in resultant computation            * )

       LS@ DUPINDEX@ #1+		( ar Ri LS LS i+1 )
       ' :: SWAP LENCOMP #= ; POSCOMP	( ar Ri LS #pos )
       DUP#0=csedrp SETSIZEERR
       NTHCOMPDROP			( ar Ri Si )

       ( * Normalize Si[x,z] to make result monic * )
       ( * in z at evaluation points z=RootOf[Ri] * )

       DUP CARCOMP			( ar Ri Si w )
       3PICK EEA 3DROP			( ar Ri Si s )
       3PICK CARCOMP			( ar Ri Si s lc[Ri] )
       OVER LENCOMP #1-			( ar Ri Si s lc[Ri] d[s,z] )
       5PICK LENCOMP #2-		( ar Ri Si s lc[Ri] d[s,z] d[Ri,z]-1 )
       INDEX@ #1- #* #+ PPow# 		( ar Ri Si s c )
       ONE CKMkP QMul			( ar Ri Si s*c )
       ONE CKMkP QMul			( ar Ri Si*s*c )
       OVER RemCoeff PPP DROP		( ar Ri Si' )

       ( * integral = sum[ a=RootOf[Ri], Si[x,a] ] * ) 

       HXS 2 10 
       Rvars@ CARCOMP ID Z 
       Rvars@ CDRCOMP 
       INNERCOMP #2+ {}N
       4ROLL ONE CKMkP HXS 2 10 3PICK R2A
       4UNROLL R2A
     ;
  LOOP
  ABND
;

* add an implicit secondary variable to a polynomial  
* Q(x,y,..) -> Q(x,w,y,..)

NULLNAME AddVar		( Q --> Q+ )
::
  DUPTYPELIST? NOT?SEMI		( -> Z )
  FIVE 
  BEGIN				( .. P offset )
    NEXTCOMPOB
  WHILE
    ONE CKMkP UNROT		( .. pi+ P offset' )
  REPEAT
  LENCOMP {}N			( P+ )
;

* remainder of P[x,y]/Q[y] w.r.t secondary variable y 
* assumes the division possible

NULLNAME RemCoeff	( P[x,y] Q[y] --> P'[x,y] )
::
  SWAP FIVE			( Q P offset )
  BEGIN				
    NEXTCOMPOB
  WHILE				( Q P offset' pi )
    4PICK QDivRem 		( Q P offset' qi ri )
    SWAPDROP			( Q P offset' ri )
    4UNROLL			( ri Q P offset' )
  REPEAT
  SWAPDROP			( rn..r1 P )
  LENCOMP {}N			( P' )
  PTrim
;    

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		EEA
* Desc:		Extended Euclid Algorithm
*		   s1/s2 * a + t1/t2 * b = GCD(a,b) 
*		   deg(s1,x)<deg(b,x) & deg(t1,x)<deg(a,x)
*		   deg(t2,x)=deg(t1,x)=0
* Stack:	( a b --> s1 s2 t1 t2 )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME EEA
::
  PPP ROT				( d cont[b] a )
  PPP ROT				( d c cont[a] cont[b] )
  2DUP QGcd				( d c cont[a] cont[b] g )
  SWAPOVER QDiv				( d c cont[a] g gb )
  5UNROLL QDiv				( gb d c ga )
  4UNROLL HXS 2 10 HXS 1 0		( ga gb d c c1 c2 )
  4ROLL HXS 1 0 HXS 2 10		( ga gb c c1 c2 d d1 d2 )
  BEGIN					( - c c1 c2 d d1 d2 )
    3PICK DupQIsZero? NOT		( - c c1 c2 d d1 d2 d flag )
  WHILE					( - c c1 c2 d d1 d2 d )
    7ROLL SWAP PseudoDiv		( - c1 c2 d d1 d2 q r h )
    8ROLL OVER QMul			( - c2 d d1 d2 q r h c1*h )
    6PICK 5PICK QMul 			( - c2 d d1 d2 q r h c1*h d1*q )
    QSub PTrim				( - c2 d d1 d2 q r h r1 )
    8ROLL ROT QMul			( - d d1 d2 q r r1 c2*h )
    5PICK 5ROLL QMul 			( - d d1 d2 r r1 c2*h d2*q )
    QSub PTrim				( - d d1 d2 r r1 r2 )
  REPEAT
  4DROP ROT				( ga gb c1 c2 c )
  PPP SWAPDROP				( ga gb c1 c2 cont[c] )
  5ROLL OVER QMul			( gb c1 c2 cont[c] ga*cont[c] )
  4ROLLSWAP 				( gb c2 cont[c] c1 ga*cont[c] )
  ONE CKMkP RCanno			( gb c2 cont[c] s1 s2 )
  ROT 5ROLL QMul			( c2 s1 s2 cont[c]*gb )
  4ROLLSWAP 				( s1 s2 c2 cont[c]*gb )
  ONE CKMkP RCanno			( s1 s2 t1 t2 )
;

**********************************************************************
* Name:		xRESULTANT
* Desc:		Calculate resultant of two polynomials
* Stack:	( symb1 symb2 var --> symb )
* Notes:
*		Let deg(a)=m and deg(b)=n, deg(c)=0. Then
*
*			res(a,0) = 0
*			res(a,b) = 1			if m=n=0
*			res(a,c) = c^m			if m>0
*			res(a,a) = 0			if m>0
*			res(a,b) = (-1)^(mn)*res(b,a)
*			res(c*a,b) = c^n*res(a,b)
*			res(x^k*a,b) = b0^k*res(a,B)	e.g. b0=const(B)
*
*		Thus if m>0 and n>0 and both have constant denominators
*		res(a/c,b/d) = (1/c)^n*(1/d)^m*res(a,b)
*
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME RESULTANT
::
  CK3&Dispatch
    #AA6
	:: FastLib			( A B var )			
	   AA2PP1{}			( Lvars Q1 Q2 )
	   Resultant			( Lvars Lm res )
	   SWAPDROPSWAP CDRCOMP		( res Lvars' )
	   ZERO #TWO#TWO CACHE		( res )
	   DUPTYPEHSTR? ITE HXS 2 10 PPZ ( res Z )
	   SWAP ONE TWO{}N ONE{}N	( z {{res 1}} )
	   SWAP HXS 2 10		( Lf z 1 )
	   FF2SS SSign			( Meta' )
	   CKSymbN			( symb )
	   ABND
	;
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Name:		Resultant
* Desc:		Resultant computation w.r.t main variable 
*		using reduced P.R.S
*
* Stack:	( a b --> Lm |res| )
*
*		|res| = absolute value of resultant as polynomial in 
*			remaining variables or integer
*		Lm    = remainder sequence { p1 p2 .. pk } 
*		pi    = polynomial in all variables (p1=a, p2=b)
*
* Note:		Assumes deg(a,x)<deg(b,x)
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

NULLNAME Resultant
::
  DUPTYPELIST? ITE DUPLENCOMP ONE		( u v dv )
  3PICK DUPTYPELIST? ITE LENCOMP DROPONE	( u v dv du )
  2DUP SWAP#- 					( u v dv du d )
  HXS 2 10 DUP					( u v dv du d s h )
  {{ v u d s h }}				( u v )
  ZERO UNROT					( S u v )
  BEGIN
    v #1<>
  WHILE
    2DUP PseudoDiv ROTDROP			( S u v h*r g )
    h SWAP h! QDiv				( S u v r )
    DUPTYPELIST? ITE DUPLENCOMP ONE		( S u v r dr )
    v OVER #-					( S u v r dr dd )
    DUP#1= ?SKIP
      ::
	4PICK CARCOMP				( S u v r dr dd lcoeff[v] )
	OVER #1- d #* PPow#			( S u v r dr dd a )
	s QMul s!				( S u v r dr dd )
      ;
    d! v u! v!					( S u v r )
    4ROLL #1+ UNROT				( S&u v r )
  REPEAT
  ROT #1+SWAP					( S&u v )
  DUPTYPELIST? IT CARCOMP			( S&u av )
  u #1- PPow#					( S&u av^du )
  s QDiv DUP PSetSign				( S&u res )
  ABND
  
  OVER#2+UNROLL					( res S&u )
  {}N SWAP					( Lrem res )
;  


**********************************************************************
* Name:		xROOTS
* Desc:		Find roots of polynomial
* Stack:	( symb var --> Lf )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME ROOTS
::
  CK2&Dispatch
  symidnt
	::
	  FastLib
	  OVERSWAP PVars{}		( symb vars )
	  DUPUNROT A2R			( vars P Q )
	  TYPEHSTR? NcaseTYPEERR	( vars P )
	  DUPTYPELIST? NcaseTYPEERR	( vars P )
	  SWAP Roots {}N		( Lf )
	;
  idntidnt
	::
	  EQUALcase { { %0 %1 } }
	  SETTYPEERR
	;
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Univariate symbolic root finder
* Stack:	( P Lvars --> Meta )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

NULLNAME Roots
::
  DUPTWO MINUSONE SUBCOMP		( P Lvars v )
  SWAP CARCOMP				( P v var )
  { LAM vars LAM var }
  BIND					( P )
  DUPLENCOMP #>1 NcaseTYPEERR		( * Error for constant polynomial * )
  RootFactor				( Lf )
  ZEROSWAP DUP >R			( 0 Lf )
  LENCOMP ZERO_DO (DO)			( Meta )
	RSWAP 'R RSWAP			( Meta Lfi )
	INCOMPDROP SWAP			( Meta #pow Pi )
	RootsIrred			( Meta #pow Meta2 )
	get1 UNCOERCE			( Meta Meta2 %pow )
	OVER ZERO_DO (DO)
	   OVER #2+ROLL
	   OVER TWO{}N UNROT
	LOOP
	DROP				( Meta Meta2' )
	top&				( Meta' )
  LOOP
  ABND
  ( RDROP )
;

*---------------------------------------------------------------------
* Desc:		Find roots of irreducible polynomial
* Stack:	( P --> Meta )
* Notes:	LAM vars and LAM var bound to
*		remaining and main variables respectively.
*---------------------------------------------------------------------

NULLNAME RootsIrred
::
   DUPLENCOMP
   ONE   #=casedrop SETSIZEERR		( * Constant * )
   TWO   #=casedrop Roots1		( * Linear * )
   THREE #=casedrop Roots2		( * Quadratic * )
*  FOUR  #=casedrop Roots3		( * Cubic * )

*  Insert polynomial decomposition test

*  FIVE  #=casedrop Roots4		( * Quartic * )

*  Insert radical root finder

   DROP HXS 2 10			( P Z1 )
   LAM vars LAM var >HCOMP		( P Z1 Lvars )
   R2A					( symb )
   syminner				( Mpoly )
   SYMBOL ID RootOf ; ONE		( Mpoly Mroot 1 )
   ' xFCNAPPLY				( Mpoly Mroot fcn )
   4ROLL #3+ SYMBN			( symb' )
   ONE					( Meta )
;

*---------------------------------------------------------------------
* Desc:		Find root of a linear polynomial a*x+b
* Stack:	( P --> root ONE )
*---------------------------------------------------------------------

NULLNAME Roots1
::
  INCOMPDROP				( a b )
  QNeg SWAP RCanno			( -b a )
  LAM vars R2A ONE			( '-b/a' )
;

*---------------------------------------------------------------------
* Desc:		Find roots of a quadratic polynomial ax^2+bx+c
* Stack.	( P --> root1 root2 TWO )
* Notes:	P is assumed irreducible, ie discriminant is
*		not a square.
*---------------------------------------------------------------------

NULLNAME Roots2
::
  INCOMPDROP				( a b c )
  OVERDUP QMul				( a b c b^2 )
  HXS 2 40 5PICK QMul ROT QMul QSub	( a b b^2-4ac )
  UNROT					( b^2-4ac a b )
  QNeg SWAP HXS 2 20 QMul		( b^2-4ac -b 2a )
  DUPUNROT				( b^2-4ac 2a -b 2a )
  RCanno LAM vars R2A			( b^2-4ac 2a '-b/2a' )
  ROT QSqrt				( 2a '-b/2a' f r )
  DupZIsOne? casedrop SETSIZEERR	( * Should be irreducible! * )
  4ROLL ROTSWAP				( '-b/2a' r f 2a )
  LAM vars R2A				( '-b/2a' r 'f/2a' )
  SWAP					( '-b/2a' 'f/2a' r )

  ( Do not extract 'i' from symbolic roots )
  DUPTYPELIST? ITE
  ::
    HXS 2 10 LAM vars R2A		( '-b/2a' 'f/2a' 'r' )
    syminner putop: xSQRT SYMBN		( '-b/2a' 'f/2a' 'sqrt[r]' )
  ;
  ::
    DupZIsNeg? DUPUNROT IT QNeg		( '-b/2a' 'f/2a' flag |r| )
    DupZIsOne? case2drop SYMBOL xi ;	( '-b/2a' 'f/2a' 'i' )
    Z>R ' xSQRT TWO			( '-b/2a' 'f/2a' flag Mroot )
    get1 NOTcase SYMBN			( '-b/2a' 'f/2a' 'sqrt[|r|]' )
    putop2: xi x* SYMBN			( '-b/2a' 'f/2a' 'sqrt[|r|]*i' )
  ;

  XMul 2DUP XAdd UNROT XSub TWO		( 'root1' 'root2' TWO )
;

*---------------------------------------------------------------------
* Desc:		Find roots of a cubic polynomial ax^3+bx^2+cx+d
* Stack:	( P --> root1 root2 root3 THREE )
*---------------------------------------------------------------------

NULLNAME Roots3
::
  INCOMPDROP				( a b c d )
  SETSIZEERR				( * Not implemented * )
;

*---------------------------------------------------------------------
* Desc:		Find roots of a quartic polynomial ax^4+bx^3+cx^2+dx+e
* Stack:	( P --> root1 root2 root3 root4 FOUR )
*---------------------------------------------------------------------

NULLNAME Roots4
::
  INCOMPDROP				( a b c d e )
  SETSIZEERR				( * Not implemented * )
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Extract square factors from polynomial
* Stack:	( Q --> Qint Qroot )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

NULLNAME QSqrt
::
  TWO QRoot
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Plain univariate factorization in main variable
* Stack:	( Q --> Lf )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

NULLNAME RootFactor
::
  PPP DROP				( * Remove content * )
  DUPTYPEHSTR? casedrop NULL{}		( * Trivial case * )
  PFactor
  DROP
;

**********************************************************************
* Name:		ADER
* Desc:		Replacement for built-in derivative function
* Stack:	( sym var --> sym' )
**********************************************************************
ASSEMBLE
	CON(3)	0		* Function
RPL
xNAME ADER
::
  CK2&Dispatch
    realidnt	:: 2DROP %0 ;
    reallam	:: 2DROP %0 ;
    symidnt	:: FastLib DeriveSym ;
    symlam	:: FastLib DeriveSym ;
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Derive function
* Stack:	( sym var --> sym' )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME DeriveSym
::
  SWAP verysyminner get1		( Meta var )
  DeriveMeta				( Meta' )
  veryunsymin				( sym' )
;

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Desc:		Derive function
* Stack:	( Meta var --> Meta' )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
NULLNAME DeriveMeta
::
  1LAMBIND				( Meta )
  DeriveOn				( Meta' )
  Derive				( Meta'' )
  DeriveOff				( Meta''' )
  ABND
;

*---------------------------------------------------------------------
* Desc:		Derive function for meta objects in derive form
* Stack:	( Meta --> Meta' )
*---------------------------------------------------------------------
NULLNAME Derive
::
  AEQ1stcase x= DerEqu
  Constant? case NDROP0ONE		( --> %0 #1 )
  DUP#1= case2drop :: %1 ONE ;		( var --> 1 )


* Dispatch based on function

  CODE

DERPRG	MACRO
	CON(5)	=$1	* Function address
	REL(5)	$2	* Handler
DERPRG	ENDM

		GOSBVL	=SAVPTR
		D1=D1+	5
		A=DAT1	A		A[A] = ->function
		GOSUB	derdispatch

	DERPRG	x+,Der+
	DERPRG	x-,Der-
	DERPRG	x*,Der*
	DERPRG	x/,Der/
	DERPRG	xNEG,DerNeg
	DERPRG	xINV,DerInv
	DERPRG	x^,DerPow		?
	DERPRG	xSQRT,DerSqrt
	DERPRG	xSQ,DerSq
	DERPRG	xEXP,DerExp
	DERPRG	xALOG,DerALog
	DERPRG	xLN,DerLn
	DERPRG	xLOG,DerLog
	DERPRG	xLNP1,DerLnp1
	DERPRG	xEXPM,DerExpm
	DERPRG	xSIN,DerSin
	DERPRG	xCOS,DerCos
	DERPRG	xTAN,DerTan
	DERPRG	xSINH,DerSinh
	DERPRG	xCOSH,DerCosh
	DERPRG	xTANH,DerTanh
	DERPRG	xASIN,DerASin
	DERPRG	xACOS,DerACos
	DERPRG	xATAN,DerATan
	DERPRG	xASINH,DerASinh
	DERPRG	xACOSH,DerACosh
	DERPRG	xATANH,DerATanh
	DERPRG	xIFTE,DerIfte
	DERPRG	xABS,DerAbs
	DERPRG	xCONJ,DerConj
	DERPRG	xARG,DerArg
	DERPRG	xDER,DerDer
*	DERPRG	xINTEGRAL,DerIntg	?
	DERPRG	xSUM,DerSum		?
*	DERPRG	xWHERE,DerWhere		?
*	DERPRG	xAPPLY,DerApply		?
	DERPRG	xFCNAPPLY,DerFcnApply	?
	CON(5)	0

derdispatch	C=RSTK
		D0=C			->table
-		C=DAT0	A		->function[i]
		?C=0	A
		GOYES	+		End of table - no match
		D0=D0+	10
		?C#A	A
		GOYES	-		Loop until match
		D0=D0-	5
		A=DAT0	A
		CD0EX
		A=A+C	A		->dispatchee
		GOVLNG	=GPPushALp	Push dispatchee
+		GOSBVL	=GETPTR
		GOVLNG	(=SKIP)+5
  ENDCODE

  COLA_EVAL				( *Evaluate dispatchee* )

* Return 'ADER(args,var)'

  putop2: derive xADER
  putop2: TWO xFCNAPPLY

;

*---------------------------------------------------------------------
* (a+b)' = a'+b'
*---------------------------------------------------------------------
LABEL Der+
:: plDRPpZparg Derive psh Derive do+ ;

*---------------------------------------------------------------------
* (a-b)' = a'-b'
*---------------------------------------------------------------------
LABEL Der-
:: plDRPpZparg Derive psh Derive do- ;

*---------------------------------------------------------------------
* (ab)' = a'b+ab'
*---------------------------------------------------------------------
LABEL Der*
:: metaDUP
   plDRPpZparg Derive psh do*
   psh pullDROP splitonearg Derive do*
   do+
;

*---------------------------------------------------------------------
* (a/b)' = (a'b-b'a)/b^2
*---------------------------------------------------------------------
LABEL Der/
:: metaDUP metaDUP
   plDRPpZparg Derive psh do*
   psh pullDROP splitonearg Derive do*
   do-
   psh plDRPpZparg NDROP dosq
   do/
;

*---------------------------------------------------------------------
* (-a)' = -(a')
*---------------------------------------------------------------------
LABEL DerNeg
:: pullDROP Derive doneg ;

*---------------------------------------------------------------------
* (1/a)' = -a'/a^2
*---------------------------------------------------------------------
LABEL DerInv
:: pullDROP metaDUP Derive psh dosq do/ doneg ;

*---------------------------------------------------------------------
* (a^b)' = a'*b*a^(b-1)+ln(a)*b'*a^b
*---------------------------------------------------------------------
LABEL DerPow
:: metaDUP metaDUP
   plDRPpZparg Derive psh do*
   psh pullDROP splitonearg do1- dopow do*
   psh metaDUP
   plDRPpZparg putop: xLN psh Derive do*
   psh do* do+
;

*---------------------------------------------------------------------
* sqrt(a)' = a'/(2*sqrt(a)) 
*---------------------------------------------------------------------
LABEL DerSqrt
:: metaDUP pullDROP Derive psh do2* do/ ;

*---------------------------------------------------------------------
* sq(a)' = 2*a*a'
*---------------------------------------------------------------------
LABEL DerSq
:: pullDROP metaDUP Derive do* do2* ;

*---------------------------------------------------------------------
* sin(a)' = cos(a)*a'*trig
*---------------------------------------------------------------------
LABEL DerSin
:: swapop: xCOS
   metaDUP pullDROP Derive do*
   DerTrig
;

*---------------------------------------------------------------------
* cos(a)' = -sin(a)*a'*trig
*---------------------------------------------------------------------
LABEL DerCos
:: swapop: xSIN
   metaDUP pullDROP Derive do*
   DerTrig doneg
;

*---------------------------------------------------------------------
* tan(a)' = [1+tan(a)^2]*a'*trig
*---------------------------------------------------------------------
LABEL DerTan
:: metaDUP dosq
   %1 psh1top& onlyputop+
   psh pullDROP Derive do*
   DerTrig
;

*---------------------------------------------------------------------
* sinh(a)' = cosh(a)*a'
*---------------------------------------------------------------------
LABEL DerSinh
:: swapop: xCOSH
   metaDUP pullDROP Derive do*
;

*---------------------------------------------------------------------
* cosh(a)' = sinh(a)*a'
*---------------------------------------------------------------------
LABEL DerCosh
:: swapop: xSINH
   metaDUP pullDROP Derive do*
;

*---------------------------------------------------------------------
* tanh(a)' = a'/cosh(a)^2
*---------------------------------------------------------------------
LABEL DerTanh
:: metaDUP pullDROP Derive
   psh swapop: xCOSH dosq do/
;

*---------------------------------------------------------------------
* asin(a)' = a'/sqrt(1-a^2)*invtrig
*---------------------------------------------------------------------
LABEL DerASin
:: pullDROP metaDUP Derive
   psh dosq
   %1 psh1top& putop2: x- xSQRT do/
   DerInvTrig
;

*---------------------------------------------------------------------
* acos(a)' = -a'/sqrt(1-a^2)*invtrig
*---------------------------------------------------------------------
LABEL DerACos
:: pullDROP metaDUP Derive
   psh dosq
   %1 psh1top& putop2: x- xSQRT do/
   DerInvTrig doneg
;

*---------------------------------------------------------------------
* atan(a)' = a'/(1+a^2)*invtrig
*---------------------------------------------------------------------
LABEL DerATan
:: pullDROP metaDUP Derive
   psh dosq
   %1 psh1top& onlyputop+ do/
   DerInvTrig
;

*---------------------------------------------------------------------
* asinh(a)' = a'/sqrt(a^2+1)
*---------------------------------------------------------------------
LABEL DerASinh
:: pullDROP metaDUP Derive
   psh dosq
   putop2: %1 x+ putop: xSQRT do/
;

*---------------------------------------------------------------------
* acosh(a)' = a'/sqrt(a^2-1)
*---------------------------------------------------------------------
LABEL DerACosh
:: pullDROP metaDUP Derive
   psh dosq
   putop2: %1 x- putop: xSQRT do/
;

*---------------------------------------------------------------------
* atanh(a)' = a'/(1-a^2)
*---------------------------------------------------------------------
LABEL DerATanh
:: pullDROP metaDUP Derive
   psh dosq
   %1 psh1top& onlyputop- do/
;

*---------------------------------------------------------------------
* exp(a)' = exp(a)*a'
*---------------------------------------------------------------------
LABEL DerExp
LABEL DerExpm
:: metaDUP pullDROP Derive do* ;

*---------------------------------------------------------------------
* alog(a)' = alog(a)*a'*ln(10)
*---------------------------------------------------------------------
LABEL DerALog
:: metaDUP pullDROP Derive do*
   { %10 xLN } INNERCOMP do*
;

*---------------------------------------------------------------------
* ln(a)' = a'/a
*---------------------------------------------------------------------
LABEL DerLn
:: pullDROP metaDUP Derive psh do/ ;

*---------------------------------------------------------------------
* log(a)' = a'/(a*ln(10))
*---------------------------------------------------------------------
LABEL DerLog
:: pullDROP metaDUP Derive
   psh { %10 xLN } INNERCOMP do*
   do/
;

*---------------------------------------------------------------------
* lnp1(a)' = a'/(a+1)
*---------------------------------------------------------------------
LABEL DerLnp1
:: pullDROP metaDUP Derive
   psh putop2: %1 x+ do/
;

*---------------------------------------------------------------------
* ifte(a,b,c)' = ifte(a,b',c')
*---------------------------------------------------------------------
LABEL DerIfte
:: pullDROP
   splitonearg Derive psh
   splitonearg Derive top& pshtop&
   putop: xIFTE
;

*---------------------------------------------------------------------
* (a=b)' = a'=b'
*---------------------------------------------------------------------
NULLNAME DerEqu
:: plDRPpZparg Derive psh Derive top& putop: x= ;

*---------------------------------------------------------------------
* |a|' = [a'*conj(a)+a*a']/(|a|*2)
*---------------------------------------------------------------------
LABEL DerAbs
:: metaDUP do2* psh
   pullDROP metaDUP metaDUP Derive metaDUP
   roll2ND doconj do* unroll2ND
   doconj do* do+ psh do/
;

*---------------------------------------------------------------------
* conj(a)' = conj(a')
*---------------------------------------------------------------------
LABEL DerConj
:: pullDROP Derive doconj ;

*---------------------------------------------------------------------
* arg(a)' =  (a'/a - conj(a'/a))/2i
*---------------------------------------------------------------------
LABEL DerArg
:: pullDROP
   metaDUP metaDUP Derive metaDUP
   roll2ND do/ unroll2ND
   psh do/ putop: xCONJ do-
   { %2 xi x* } INNERCOMP do/
;

*---------------------------------------------------------------------
* (a')' =
*---------------------------------------------------------------------
LABEL DerDer
:: pullDROP
   DeriveOff
      #1- get1 DeriveMeta
   DeriveOn
   Derive
;

*---------------------------------------------------------------------
* int(a,b,c,d)' =
*---------------------------------------------------------------------
LABEL DerIntg
:: ;

*---------------------------------------------------------------------
* sum(a,b,c)' =
*---------------------------------------------------------------------
LABEL DerSum
:: pullDROP
   splitonearg Derive
   OVER j%0=case
   :: psh NDROP ;
   psh pshzerpsharg pshzerpsharg
   Constant? NOTcase
   :: NDROP NDROP NDROP NDROP0ONE ;
   pshtop& pshtop& pshtop& putop: xSUM
;

*---------------------------------------------------------------------
* where(a,b,c,d..)' =
*---------------------------------------------------------------------
LABEL DerWhere
:: ;

*---------------------------------------------------------------------
* fcn(a,b,c..)' =
*---------------------------------------------------------------------
LABEL DerFcnApply
::
  ( Check for ADER first )
  4PICK ' xADER EQUALcase
  :: #3- 4UNROLL3DROP
     DeriveOff pull DeriveMeta DeriveOn Derive
  ;
  putop2: derive xADER
  putop2: TWO xFCNAPPLY
;


*---------------------------------------------------------------------
* Desc:		Help utility for trigonometric functions
* Stack:	( Meta --> Meta&factor )
*---------------------------------------------------------------------
NULLNAME DerTrig
:: RAD? ?SEMI
   DEG? ITE
   { xPI %180 x/ x* }
   { xPI % 200 x/ x* }
   INNERCOMP top&
;

*---------------------------------------------------------------------
* Desc:		Help utility for inverse trigonometric functions
* Stack:	( Meta -- Meta&factor )
*---------------------------------------------------------------------
NULLNAME DerInvTrig
:: RAD? ?SEMI
   DEG? ITE
   { %180 xPI x/ x* }
   { % 200 xPI x/ x* }
   INNERCOMP top&
;

*---------------------------------------------------------------------
* Desc:		Help utility for derive function which replaces
*		all occurrances of the variable of derivation
*		with derive lam.
* Stack:	( Meta --> Meta' )
*		1LAM = variable
*---------------------------------------------------------------------
NULLNAME DeriveOn
::
  DUP #1+_ONE_DO (DO)
     INDEX@ DUP#2+PICK			( Meta i ob[i] )
     1GETLAM EQUAL ITE
     CODE
	GOSBVL	=POP#			A[A] = i
	CD1EX
	D1=C
	C=C+A	A
	A=A+A	A
	A=A+A	A
	A=A+C	A
	AD1EX
	LC(5)	=derive
	DAT1=C	A
	D1=A
	GOVLNG	=Loop
     ENDCODE
     DROP				( Meta )
  LOOP
;

*---------------------------------------------------------------------
* Desc:		Help utility for derive function which replaces
*		all occurances of derivation variable marker
*		with the variable itself.
* Stack:	( Meta --> Meta' )
*		1LAM = variable
*---------------------------------------------------------------------
NULLNAME DeriveOff
::
  1GETLAM				( Meta var )
  CODE
	GOSBVL	=PopASavptr
	B=A	A			B[A] = ->var
	GOSBVL	=POP#			A[A] = N = meta size
	LC(5)	=derive
	D=C	A			D[A] = ->derive marker
	D1=D1-	5
--	D1=D1+	5
	A=A-1	A
	GOC	++			Checked all of Meta - done
	C=DAT1	A
	?C#D	A
	GOYES	--			Checked stack level - next
	C=B	A
	DAT1=C	A			Replace stack level with var
	GONC	--			Loop
++	GOVLNG	=GETPTRLOOP
  ENDCODE
;

*---------------------------------------------------------------------
* Desc:		Test if Meta contains derive marker
* Stack:	( Meta --> Meta flag )
*---------------------------------------------------------------------
NULLNAME Constant?
CODE
	GOSBVL	=SAVPTR
	GOSBVL	=POP#
	B=A	A			B[A] = N = Meta size
	LC(5)	=derive			Derive marker
-	B=B-1	A			N--
	GOC	+			All tested - no marker
	A=DAT1	A
	D1=D1+	5
	?A#C	A
	GOYES	-
+	GOVLNG	=GPPushT/FLp
ENDCODE

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*		Help utilities for arithmetic
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

NULLNAME doneg
::
   OVER TYPEREAL? case
   :: SWAP %CHS SWAP ;
   M-1stcasechs NOP onlyputopCHS
;

NULLNAME do+
::
  CK&DISPATCH0
 #11F10	:: DROPSWAPDROP %+ ONE ;
  ZERO  :: AEQ1stcase %0 NDROP
	   psh
	   AEQ1stcase %0 NDROP
	   pshtop& putop+
	;
;

NULLNAME do-
::
  CK&DISPATCH0
 #11F10 :: DROPSWAPDROP %- ONE ;
  ZERO  ::
	   AEQ1stcase %0 NDROP
	   psh
	   AEQ1stcase %0 :: NDROP doneg ;
	   pshtop& putop-
	;
;

NULLNAME do*
::
  CK&DISPATCH0
 #11F10 :: DROPSWAPDROP %* ONE ;
  ZERO	::
	   AEQ1stcase %0   :: psh NDROP ;
	   AEQ1stcase %1   NDROP
	   AEQ1stcase %-1  :: NDROP doneg ;
	   psh
	   AEQ1stcase %0   :: psh NDROP ;
	   AEQ1stcase %1   NDROP
	   AEQ1stcase %-1  :: NDROP doneg ;
	   pshtop& putop*
	;
;

NULLNAME do/
::
  CK&DISPATCH0
 #11F10 :: DROPSWAPDROP j%0=case
	   :: ' x/ THREE ;
	   2DUP %/ %FP %0= case
	   :: %/ ONE ;
	   ' x/ THREE
	;
  ZERO	::
	   AEQ1stcase %1   NDROP
	   AEQ1stcase %-1  :: NDROP doneg ;
	   psh
	   AEQ1stcase %0   :: psh NDROP ;
	   pshtop& putop/
	;
;

NULLNAME dosq
:: OVER TYPEREAL? case
   :: SWAPDUP %* SWAP ;
   AEQ1stcase xSQRT pullDROP
   AEQ1stcase xi    :: swapop: %-1 ;
   MEQ^case         :: swapop: %2 putop2: x* x^ ;
   putop2: %2 x^
;

NULLNAME dopow
:: AEQ1stcase %0  :: NDROP NDROP1ONE ;
   AEQ1stcase %1  NDROP
   top& putop: x^
;

NULLNAME do2*
:: OVER TYPEREAL? case
   :: SWAP %2 %* SWAP ;
   %2 psh1top& onlyputop*
;

NULLNAME do1-
:: OVER TYPEREAL? case
   :: SWAP %1- SWAP ;
   putop2: %1 x-
;

NULLNAME doconj
:: OVER TYPEREAL? ?SEMI
   putop: xCONJ
;

**********************************************************************

