	STITLE	ALG Z Rat
**********************************************************************
*		ALG Library: Rational Routines
**********************************************************************

**********************************************************************
* EXPORT:
*
*   RAdd	( An Ad Bn Bd --> Cn Cd )
*   RSub	( An Ad Bn Bd --> Cn Cd )
*   RMul	( An Ad Bn Bd --> Cn Cd )
*   RPow	( An Ad Z --> Cn Cd )
*
*   RGcd	( An Ad Bn Bd --> Gn Gd )
*   RLcm	( An Ad Bn Bd --> Gn Gd )
**********************************************************************


**********************************************************************
* Desc:		Add two rationals
* Stack:	( An Ad Bn Bd --> Cn Cd )
**********************************************************************
NULLNAME RAdd
::
  3PICKOVER EQUAL
  casedrop :: ROTSWAP QAdd SWAP ;
  SWAP3PICK QMul		( An Ad Bd Bn*Ad )
  OVER 5ROLL QMul		( Ad Bd Bn*Ad Bd*An )
  QAdd				( Ad Bd Cn )
  UNROT QMul			( Cn Cd )
;

**********************************************************************
* Desc:		Substract two rationals
* Stack:	( An Ad Bn Bd --> Cn Cd )
**********************************************************************
NULLNAME RSub
::
  3PICKOVER EQUAL
  casedrop :: ROTSWAP QSub SWAP ;
  SWAP3PICK QMul		( An Ad Bd Bn*Ad )
  OVER 5ROLL QMul		( Ad Bd Bn*Ad Bd*An )
  SWAP QSub			( Ad Bd Cn )
  UNROT QMul			( Cn Cd )
;

**********************************************************************
* Desc:		Multiply two rationals
* Stack:	( An Ad Bn Bd --> Cn Cd )
**********************************************************************
NULLNAME RMul
::
  ROT QMul		( An Bn Bd*Ad )
  UNROT QMul		( Cd Cn )
  SWAP			( Cn Cd )
;

**********************************************************************
* Desc:		Raise a rational to the Zth power
* Stack:	( An Ad Z --> Cn Cd )
**********************************************************************
NULLNAME RPow
::
  DupZIsNeg?		( An Ad Z Sflag )
  DUP 5UNROLL		( Sflag An Ad Z Slag )
  IT QNeg HXS>#		( Sflag An Ad # )
  SWAPOVER PPow#	( Sflag An # Ad^# )
  4UNROLL PPow#		( Ad^# Sflag An^# )
  UNROT			( An^# Ad^# Sflag )
  IT SWAP		( Cn Cd )
;

**********************************************************************
* Desc:		Compute the GCD of two rationals
* Stack:	( An Ad Bn Bd --> Gn Gd )
**********************************************************************
NULLNAME RGcd
::
  ROT QGcd		( An Bn Gd )
  UNROT QGcd		( Gd Gn )
  SWAP			( Gn Gd )
;

**********************************************************************
* Desc:		Compute the LCM of two rationals
* Stack:	( An Ad Bn Bd --> Gn Gd )
**********************************************************************
NULLNAME RLcm
::
  ROT QLcm		( An Bn Gd )
  UNROT QLcm		( Gd Gn )
  SWAP			( Gn Gd )
;

**********************************************************************

