	STITLE	ALG Simplification
**********************************************************************
*	ALG Library:	Simplification routines
**********************************************************************

**********************************************************************
* EXPORT:
*
* ARSim		( sym --> sym' )
* RSim		( sym --> sym' )
* RSim0		( sym --> Pn Pd vars )
* RSimVars	( symb {vars} --> Pn Pd Lvars )
* RCanno	( Q1 Q2 --> Q1' Q2' )
*
* CKSymList	( {} --> {} / Error )
*
**********************************************************************

**********************************************************************
* Desc:		Does AlgRSim if AutoSimFlag is set
* Stack:	( Sym --> Sym' )
**********************************************************************
NULLNAME ARSim
::
  AutoSimFlag TestUserFlag
  case RSim
;

**********************************************************************
* Desc:		Simplify into rational form
* Stack:	( Sym Sym' )
**********************************************************************
NULLNAME RSim
::
   CK&DISPATCH0
	real	NOP
	idnt	NOP
	lam	NOP
	symb	::
		   DUP DUPLENCOMP NTHCOMPDROP		( symb ob )
		   EQ: x= NOTcase
		   :: RSim0 R2A ;

		   INNERCOMP plDRPpZparg		( Meta2 Meta1 )
		   veryunsymin RSim			( Meta2 symb1 )
		   OVER#2+UNROLL			( symb1 Meta2 )
		   veryunsymin RSim			( symb1 symb2 )
		   syminnertwo top& putop: x= SYMBN	( symb' )
		;
;

**********************************************************************
* Desc:		Simplify symbolic into rational
* Stack:	( Sym --> Pn Pd vars )
**********************************************************************
NULLNAME RSim0
::
  DUP PVars			( Sym v )
  DUPUNROT A2R			( v Pn Pd )
  RCanno			( v Pn' Pd' )
  ROT 				( Pn' Pd' v )
;

**********************************************************************
* Name:		RSimVars
* Desc:		Simplification with preferred variables
* Stack:	( symb {vars} --> Pn Pd Lvars )
**********************************************************************
NULLNAME RSimVars
::
  OVERSWAP PVars{}		( symb Lvars )
  DUPUNROT A2R			( Lvars Pn Pd )
  RCanno			( Lvars Pn' Pd' )
  ROT				( Pn' Pd' Lvars )
;

**********************************************************************
* Desc:		Makes a rational canonical by removing the gcd
*		of the num and den
* Stack:	( Q1 Q2 --> Q1' Q2' )	
**********************************************************************
NULLNAME RCanno
::
  SWAP PTrim
  SWAP PTrim				( Q1 Q2 )
  CODE
		GOSBVL	=SAVPTR		Try short integer special case
		GOSUBL	SHORTPOPRAT?	B[W]D[S]=Z2	A[W]C[S]=Z1
		GOC	zcannofail	Couldn't get 2 short integers
		C=C+D	S		Multiply the signs
		GONC	+
		C=0	S		negneg=pos
+		R1=C.F	S		R1[S]=Z1'sign
		C=B	W
		GOSUBL	SHORTCANNO	A[W]=N1'	C[W]=N2'
		CR1EX	W		C[S]=sign	R1[W]=Z2'
		GOSUBL	PushZ		Push nominator
		A=DAT1	A		Overwrite old Q1 with the nominator
		D1=D1+	10
		DAT1=A	A
		D=D+1	A
		D=D+1	A
		GOSBVL	=SAVPTR
		A=R1	W		A[W]=Z2'
		GOSUBL	PushN		Push denominator
		GOVLNG	=PushTLoop
zcannofail	GOVLNG	=GPPushFLoop
  ENDCODE
  ?SEMI
  2DUP QGcd 			( Q1 Q2 G+ )
  OVER PSetSign			( Q1 Q2 G )
  ROTOVER QDiv			( Q2 G Q1' )
  UNROT	QDiv			( Q1' Q2' )
;

**********************************************************************
* Name:		CkSymList
* Desc:		Check elements of list are all of symbolic type
* Stack:	( {} --> {} / error )
**********************************************************************
NULLNAME CKSymList
::
  FIVE
  BEGIN
     NEXTCOMPOB
  WHILE
     CK&DISPATCH0 sym DROP
  REPEAT
;

**********************************************************************
