	STITLE	ALG User Cmd

**********************************************************************
*		ALG48 ROMID Declaration
**********************************************************************
xROMID 38D ( 909 )
ASSEMBLE
=ALGROMID	EQU #38D
RPL

**********************************************************************
*		Configuration Object
**********************************************************************

ASSEMBLE
=ALGcfg
RPL
::
  [#] ALGROMID TOSRRP ( autoattach )
;

**********************************************************************
*		ALG Library User Commands
**********************************************************************

**********************************************************************
* Name:		xRSIM
* Desc:		Multivariate rational simplification
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME RSIM
::
  CK1&Dispatch 
	real	NOP
	idnt	NOP
	lam	NOP
	symb	:: FastLib TypeMod1? NOTcase RSim ROT P2AMOD ;
	list	:: FastLib RESOROMP RSim DoP ;
; 

**********************************************************************
* Name:		xFCTR
* Desc:		Multivariate factorization
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME FCTR
::
  CK1&Dispatch
	real	NOP
	idnt	NOP
	lam	NOP				( not implemented )
	symb	:: FastLib TypeMod1? NOTcase RFactor SETTYPEERR ;
	list	:: FastLib RESOROMP RFactor DoP ;
	hxs	:: FastLib H>Z ZFactor ;
	str	:: FastLib S>Z ZFactorSym ;
; 

**********************************************************************
* Name:		xAADD
* Desc:		General addition command
* Notes:	Has alias x+
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME AADD
::
  CK2&Dispatch 
	listlist	:: FastLib MAdd ;
	listreal	:: FastLib MAddS ;
	listsym		:: FastLib MAddS ;
	reallist	:: FastLib SWAP MAddS ;
	symlist		:: FastLib SWAP MAddS ;
	symsym		:: FastLib TypeMod2? NOTcase
			   :: 'EvalNoCK: x+ ARSim ;
			   DUP4UNROLL QAddMod SWAPROT P2AMOD
			;
	symreal		:: 'EvalNoCK: x+ FastLib ARSim ;
	realsym		:: 'EvalNoCK: x+ FastLib ARSim ;
	hxshxs		:: FastLib CK2Z QAdd ;
	hxsreal		:: FastLib CK2Z QAdd ;
	realhxs		:: FastLib CK2Z QAdd ;
	any		x+
;
* Alias 
x+

**********************************************************************
* Name:		xASUB
* Desc:		General substration command
* Notes:	Has alias x-
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME ASUB
::
  CK2&Dispatch 
	listlist	:: FastLib MSub ;
	listreal	:: FastLib MSubS ;
	listsym		:: FastLib MSubS ;
	reallist	:: FastLib SSubM ;
	symlist		:: FastLib SSubM ;
	symsym		:: FastLib TypeMod2? NOTcase
			   :: 'EvalNoCK: x- ARSim ;
			   DUP4UNROLL QSubMod SWAPROT P2AMOD
			;
	symreal		:: 'EvalNoCK: x- FastLib ARSim ;
	realsym		:: 'EvalNoCK: x- FastLib ARSim ;
	hxshxs		:: FastLib H>Z SWAP H>Z SWAP QSub ;
	hxsreal		:: FastLib R>Z SWAP H>Z SWAP QSub ;
	realhxs		:: FastLib H>Z SWAP R>Z SWAP QSub ;
	any		x-
; 
* Alias 
x-

**********************************************************************
* Names:	xAMUL
* Desc:		General multiplication command
* Notes:	Has alias x*
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME AMUL
::
  CK2&Dispatch 
	listlist	:: FastLib MMul ;
	listreal	:: FastLib MMulS ;
	listsym		:: FastLib MMulS ;
	reallist	:: FastLib SWAP MMulS ;
	symlist		:: FastLib SWAP MMulS ;
	symsym		:: FastLib TypeMod2? NOTcase
			   :: 'EvalNoCK: x* ARSim ;
			   DUP4UNROLL QMulMod SWAPROT P2AMOD
			;
	symreal		:: 'EvalNoCK: x* FastLib ARSim ;
	realsym		:: 'EvalNoCK: x* FastLib ARSim ;
	hxshxs		:: FastLib CK2Z QMul ;
	hxsreal		:: FastLib CK2Z QMul ;
	realhxs		:: FastLib CK2Z QMul ;
	any		x*
;
* Alias 
x* 

**********************************************************************
* Names:	xADIV
* Desc:		General division command
* Notes:	Has alias x/
*		Has special code for non-integer realreal input
*		to ease decimal division when assigned to the [/] key.
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME ADIV
::
  CK2&Dispatch 
	listlist	:: FastLib MDiv ;
	listreal	:: FastLib MDivS ;
	listsym		:: FastLib MDivS ;
	reallist	:: FastLib MInv SWAP MMulS ;
	symlist		:: FastLib MInv SWAP MMulS ;
	symsym		:: FastLib TypeMod2? NOTcase
			   :: 'EvalNoCK: x/ ARSim ;
			   DUP4UNROLL QDivMod		( v Zn quo rem )
			   3PICK 5PICK P2AMOD 4UNROLL	( 'rem' v Zn quo )
			   SWAPROT P2AMOD SWAP		( 'quo' 'rem' )
			;
	symreal		:: 'EvalNoCK: x/ FastLib ARSim ;
	realsym		:: 'EvalNoCK: x/ FastLib ARSim ;
	hxshxs		:: FastLib CK2Z QDiv ;
	hxsreal		:: FastLib CK2Z QDiv ;
	realhxs		:: FastLib CK2Z QDiv ;
	realreal	:: FastLib
			   OVER %FP %0<> OVER %FP %0<> ORcase %/
			   SYDiv% ARSim
			;
	any		x/
; 
* Alias 
x/

**********************************************************************
* Name:		xAPOW
* Desc:		General power
* Notes:	Has alias x^
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME APOW
::
  CK2&Dispatch 
	listreal	:: FastLib MPow% ;
	symreal		:: FastLib SWAP
			   TypeMod1? NOTcase
			   :: SWAP 'EvalNoCK: x^ ARSim ;
			   4ROLL DUP %0>= NcaseTYPEERR		( v P Zn n )
			   DUP %FP %0= NcaseTYPEERR
			   COERCE ROTSWAP PPow#			( v Zn P' )
			   OVER QMod				( v Zn P )
			   SWAPROT P2AMOD			( sym )
			;
	hxshxs		:: FastLib SWAP H>Z SWAP HXS># PPow# ;
	hxsreal		:: FastLib SWAP H>Z SWAP COERCE PPow# ;
	realhxs		:: FastLib SWAP R>Z SWAP HXS># PPow# ; 
	any		x^
;
* Alias 
x^
 
**********************************************************************
* Name:		xANEG
* Desc:		General negation
* Notes:	Has alias xNEG which is *NOT* the same as [NEG]-key
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME ANEG
::
  CK1&Dispatch 
	list 	:: FastLib MNeg ;
	hxs	:: FastLib H>Z QNeg ;
	any	:: FastLib TypeMod1? NOTcase xNEG
		   SWAP QNeg OVER QMod SWAPROT P2AMOD
		;
; 
* Alias 
xNEG

**********************************************************************
* Name:		xAINV
* Desc:		General inversion
* Notes:	Has alias xINV
*		Has special code for non-integer real input
*		to ease decimal division when assigned to the [INV] key.
**********************************************************************
ASSEMBLE
	CON(1)	#A
RPL
xNAME AINV
::
  CK1&Dispatch 
	list 	:: FastLib MInv ;
	sym	:: FastLib TypeMod1? NOTcase
		   :: 'EvalNoCK: xINV ARSim ;
		   DUPUNROT QInvMod SWAPROT P2AMOD
		;
	real	:: FastLib
		   DUP %FP %0<> case %1/
		   %1 SWAP SYDiv% ARSim
		; 
	any	xINV
; 
* Alias 
xINV

**********************************************************************
* Name:		xMDET
* Desc:		Matrix determinant
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MDET
::
  CK1&Dispatch
  list :: FastLib MDet ;
; 

**********************************************************************
* Name:		xMLU
* Desc:		LU decomposition and rank calculation
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MLU
::
  CK1&Dispatch
  list	:: FastLib MLU ;
; 

**********************************************************************
* Name:		xMTRN
* Desc:		Matrix transpose
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MTRN
::
  CK1&Dispatch
  list	:: FastLib MCKMat MTrn MNorm ;
;
 
**********************************************************************
* Name:		xMIDN
* Desc:		Identity matrix
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MIDN
::
  CK1&Dispatch
  real	:: FastLib COERCE MIdn ;
;
 
**********************************************************************
* Name:		xZ<->S
* Desc:		Long integer conversions
* Name:		Has typable alias ZS
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME Z<->S
tNAME xZ<->S ZS
::
  CK1&Dispatch
  hxs	:: FastLib Z>S ;
  str	:: FastLib S>Z ;
  real	:: FastLib R>Z ;
  list	:: FastLib '
           :: CK&DISPATCH0
		hxs  Z>S
		str  S>Z
		real R>Z
	   ;
	   DoP
	;
;

**********************************************************************
* Name:		xGCD
* Desc:		Greatest common denominator
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME GCD
::
  CK2&Dispatch
  	symsym		:: FastLib TypeMod2? NOTcase AAGcd
			   DUP4UNROLL QGcdMod SWAPROT P2AMOD
			;
	realsym		:: FastLib AAGcd ;
	symreal		:: FastLib AAGcd ;
	realreal	:: FastLib CK2Z QGcd Z>R ;
	strstr		:: FastLib CK2Z QGcd Z>S ;
	any		:: FastLib CK2Z QGcd ;
; 

**********************************************************************
* Name:		xLCM
* Desc:		Least common multiple
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME LCM
::
  CK2&Dispatch
  	symsym		:: FastLib TypeMod2? NOTcase AALcm
			   UNROT 2DUP			( v Zn P Q P Q )
			   5PICK QMulMod		( v Zn P Q PQ )
			   UNROT 4PICK QGcdMod		( v Zn PQ Gcd )
			   3PICK QDivMod DROP		( v Zn Lcm )
			   SWAPROT P2AMOD		( sym )
			;
	realsym		:: FastLib AALcm ;
	symreal		:: FastLib AALcm ;
	realreal	:: FastLib CK2Z QLcm Z>R ;
	strstr		:: FastLib CK2Z QLcm Z>S ;
	any		:: FastLib CK2Z QLcm ;
; 

**********************************************************************
* Name:		xRAT->
* Desc:		Rational nominator and denominator
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME RAT\8D
::
  CK1&Dispatch
	real		%1
	idnt		%1
	lam		%1
	symb		:: FastLib RNumDen ;
; 

**********************************************************************
* Name:		xASIM
* Desc:		Full algebraic simplification
* Notes:	This should be redirected to RSIM in light versions.
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME ASIM
::
  CK1&Dispatch 
	real	NOP
	idnt	NOP
	lam	NOP
	cmp	:: SimpOb SYMBN ;		( No FastLib needed )
	symb	:: FastLib ASim ;
	list	:: FastLib RESOROMP ASim DoP ;
; 

**********************************************************************
* Name:		xMOD+
* Desc:		Modular addition
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MOD+
::
  CK3
  FastLib CK3Z ModAdd
;

**********************************************************************
* Name:		xMOD-
* Desc:		Modular substraction
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MOD-
::
  CK3
  FastLib CK3Z ModAdd
;

**********************************************************************
* Name:		xMOD*
* Desc:		Modular multiplication
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MOD*
::
  CK3
  FastLib CK3Z ModMul
;

**********************************************************************
* Name:		xMOD/
* Desc:		Modular division
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MOD/
::
  CK3
  FastLib CK3Z ModDiv
;

**********************************************************************
* Name:		xMODPOW
* Desc:		Modular power
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODPOW
::
  CK3
  FastLib CK3Z ModPow
;

**********************************************************************
* Name:		xMODINV
* Desc:		Modular inverse
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODINV
::
  CK2
  FastLib CK2Z ModInv
;

**********************************************************************
* Name:		xPRIM?
* Desc:		Primality test
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME PRIM?
::
  CK1 FastLib CK1Z
  DupZIsNeg?  casedrop %0		( <0 is not prime )
  DupQIsZero? casedrop %0		( 0 is not prime )
  DupZIsOne?  casedrop %0		( 1 is not prime )
  ZPrime? ITE %1 %0			( Regular test )
;

**********************************************************************
* Name:		xPRIM+
* Desc:		Next prime
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME PRIM+
::
  CK1 FastLib CK1Z
  Prime+
;

**********************************************************************
* Name:		xPRIM-
* Desc:		Previous prime
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME PRIM-
::
  CK1 FastLib CK1Z
  Prime-
;

**********************************************************************
* Name:		xPRIMN
* Desc:		Nth prime
**********************************************************************
*	ASSEMBLE
*		CON(1)	8
*	RPL
*	xNAME PRIMN
*	::
*	  CK1 FastLib CK1Z
*	  DUP %0> NOTcase SYNTAXERR
*	  COERCE PrimeN
*	;

**********************************************************************
* Name:		xRORD
* Desc:		User rational re-order command
* Stack:	( symb {main vars} --> symb' )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME RORD
::
  CK2&Dispatch 
    symbsym	:: FastLib ONE{}N ROrder ;
    symsym	DROP
    realsym	DROP
    symblist	:: FastLib CKSymList ROrder ;
    symlist	:: FastLib CKSymList DROP ;
    reallist	:: FastLib CKSymList DROP ;
;

**********************************************************************
* Name:		xPF
* Desc:		User partial fraction expansion command 
*		with optional given variable sort.
* Stack:	( symb [{vars}] --> symb' )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME PF
::
  CK1&Dispatch 
    real	NOP
    idnt	NOP
    lam		NOP
    symb	:: FastLib NULL{} ParFrac ;
    list	::
		   CK2NOLASTWD
		   FastLib CKSymList
		   CK&DISPATCH1
		     reallist  DROP
		     idntlist  DROP
		     lamlist   DROP
		     symblist  ParFrac
		;
;

**********************************************************************
* Name:		xRINT
* Desc:		Rational function integration w.r.t var
* Stack:	( symb var --> symb' )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME RINT
::
  CK2&Dispatch 
    realidnt	:: FastLib XMul ;
    reallam	:: FastLib XMul ;
    symidnt	:: FastLib RatInt ;
    symlam	:: FastLib RatInt ;
;

**********************************************************************
* Name:		xGBASIS
* Desc:		Calculate Grobner basis for given set of polynomials.
* Stack:	( {eqs} {vars} --> {basis} )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME GBASIS
::
  CK2&Dispatch
  #50
  ::
	FastLib				( Leqs vars )
	DUPTYPELIST? ?SKIP ONE{}N	( Leqs Lvars )
	DUPLENCOMP UNROT		( # Leqs Lvars )
	EQS2R SWAP			( # Lvars' Lp )
	GBASIS				( # Lvars' Lg )
	UNROTSWAP R2EQS			( Lbasis )
  ;
;

**********************************************************************
* Name:		xGSOLVE
* Desc:		Calculate factorized Grobner basis for given
*		set of polynomials.
* Stack:	( {eqs} {vars} --> {basis1} .. {basisn} n )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME GSOLVE
::
  CK2&Dispatch
  #50
  ::
	FastLib				( Leqs vars )
	DUPTYPELIST? ?SKIP ONE{}N	( Leqs Lvars )
	DUPLENCOMP UNROT		( # Leqs Lvars )
	EQS2R SWAP			( # Lvars' Lp )
	GSOLVE				( # Lvars' Lg )
	DUPNULLCOMP? case :: 3DROP %0 ;	( * No solutions * )
	ZERO UNROT			( # #0 Lvars' Lg )
	toLEN_DO (DO)			( Lsol1 .. # #m-1 Lvars' Lg )
	   DUPINDEX@ NTHCOMPDROP	( Lsol1 .. # #m-1 Lvars' Lg Lgm )
	   3PICK 6PICK R2EQS		( Lsol1 .. # #m-1 Lvars' Lg Lsolm )
	   5UNROLL ROT#1+UNROT		( Lsol1 .. Lsolm # #m Lvars' Lg )
	LOOP
	2DROP SWAPDROP UNCOERCE		( Lsol1 Lsol2 .. Lsolm %m )
  ;
;

**********************************************************************
* Name:		xGSIMP
* Desc:		Calculate Grobner basis for given set of polynomials,
*		then reduce polynomial with respect to the basis.
* Stack:	( eq {eqs} {vars} --> eq' )
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME GSIMP
::
  CK3&Dispatch
  #A00
  ::
	FastLib				( eq eqs vars )
	SWAP DUPTYPELIST? ?SKIP ONE{}N	( eq vars Leqs )
	DUPLENCOMP 4UNROLL		( # eq vars Leqs )
	SWAP DUPTYPELIST? ?SKIP ONE{}N	( # eq Leqs Lvars )
	UNROTSWAP >HCOMP		( # Lvars Leq&eqs )
	SWAP EQS2R			( # Lp Lvars' )
	OVER CARCOMP ROT CDRCOMP	( # Lvars' p Lp' )
	GBASIS				( # Lvars' p Lg )
	REDUCE				( # Lvars' p' )
	HXS 2 10 ROT 4ROLL R2Aord	( eq' )
  ;
;

**********************************************************************
