	STITLE	ALG X Symb
**********************************************************************
*		ALG library: Symbolic operations
**********************************************************************

**********************************************************************
* EXPORT:
*
*   XNeg	( S --> -S )
*   XAdd	( S1 S2 --> S )
*   XSub	( S1 S2 --> S )
*   XMul	( S1 S2 --> S )
*   XDiv	( S1 S2 --> S )
**********************************************************************

**********************************************************************
* Desc:		Negate SYmbolic
* Stack:	( S --> -S )
**********************************************************************
NULLNAME SYNeg
::
  syminner
  M-1stcasechs CKSymbN
  SNeg SYMBN
;

**********************************************************************
* Desc:		
* Stack:	
**********************************************************************
NULLNAME DrpSYNeg	( S ob --> -S )
:: DROP SYNeg ;


**********************************************************************
* Desc:		Add two SYmbolics
* Stack:	( S1 S2 --> S1+S2 )
**********************************************************************
NULLNAME SYAdd
::
  syminnertwo				( Meta1 Meta2 )
  :: M-1stcasechs SSub SAdd ;		( Meta )
  SYMBN					( S )
;

**********************************************************************
* Desc:		Add SYmbolic to real
* Stack:	( S % --> S+% )
**********************************************************************
NULLNAME SYAdd%
::
  %0=case DROP		( return S )
  SYAdd
;

**********************************************************************
* Desc:		Add real to SYmbolic 
* Stack:	( % S --> %+S )
**********************************************************************
NULLNAME %AddSY
::
  OVER %0= case SWAPDROP	( return S )
  SYAdd
;

**********************************************************************
* Desc:		( S1 S2 --> S1-S2 )
* Stack:	Substract two SYmbolics
**********************************************************************
NULLNAME SYSub
::
  syminnertwo				( Meta1 Meta2 )
  :: M-1stcasechs SAdd SSub ;		( Meta )
  SYMBN					( S )
;

**********************************************************************
* Desc:		Substract real from SYmbolic 
* Stack:	( S % --> S-% )
**********************************************************************
NULLNAME SYSub%
::
  %0=case DROP		( return S )
  SYSub
;

**********************************************************************
* Desc:		Substract SYmbolic from real
* Stack:	( % S --> %-S )
**********************************************************************
NULLNAME %SubSY
::
  SWAP %0=case DrpSYNeg
  SWAP SYSub
;

**********************************************************************
* Desc:		Multiply two SYmbolics
* Stack:	( S1 S2 --> S1*S2 )
**********************************************************************
NULLNAME SYMul
:: syminnertwo SMul SYMBN ;


**********************************************************************
* Desc:		Multiply SYmbolic and real
* Stack:	( S % --> S*% )
**********************************************************************
NULLNAME SYMul%
::
   %0=case SWAPDROP		( return %0 )
   %1=case DROP			( return S )
   %-1=case DrpSYNeg		( return -S )
   SWAP SYMul			( return %*S )
;

**********************************************************************
* Desc:		Divide two SYmbolics
* Stack:	( S1 S2 --> S1/S2 )
**********************************************************************
NULLNAME SYDiv
::
  syminnertwo SDiv SYMBN
;

**********************************************************************
* Desc:		Divide SYmbolic by real
* Stack:	( S % --> S/% )
**********************************************************************
NULLNAME SYDiv%
::
   %0=case ErrInfRes		( Infinite Result Error )
   %1=case DROP			( return S )
   %-1=case DrpSYNeg		( return -S )
   SYDiv
;

**********************************************************************
* Desc:		Divide real by SYmbolic
* Stack:	( % S --> %/S )
**********************************************************************
NULLNAME %DivSY
::
  SWAP %0=case SWAPDROP		( return %0 )
  SWAP SYDiv
;

**********************************************************************
* Desc:		Negate symbolic
* Stack:	( S --> -S )
**********************************************************************
NULLNAME XNeg
::
  CK&DISPATCH0
	real	%CHS
	sym	SYNeg
;

**********************************************************************
* Desc:		Add two symbolics
* Stack:	( S1 S2 --> S )
**********************************************************************
NULLNAME XAdd
::
  CK&DISPATCH0
	realreal	%+
	symsym		SYAdd
	symreal		SYAdd%
	realsym		%AddSY
;	

**********************************************************************
* Desc:		Substract two symbolics
* Stack:	( S1 S2 --> S )
**********************************************************************
NULLNAME XSub
::
  CK&DISPATCH0
	realreal	%-
	symsym		SYSub
	symreal		SYSub%
	realsym		%SubSY
;	

**********************************************************************
* Desc:		Multiply two symbolics
* Stack:	( S1 S2 --> S )
**********************************************************************
NULLNAME XMul
::
  CK&DISPATCH0
	realreal	%*
	symsym		SYMul
	symreal		SYMul%
	realsym		:: SWAP SYMul% ;
;	


**********************************************************************
* Desc:		Divide two symbolics
* Stack:	( S1 S2 --> S )
**********************************************************************
NULLNAME XDiv
::
  CK&DISPATCH0
	realreal	SYDiv%
	symsym		SYDiv
	symreal		SYDiv%
	realsym		%DivSY
;	
**********************************************************************
